//移动端dialog、toast、loading
//示例查看：../demo/kmDialog.html

    var kmDialog = {
    	options: {
    		toastTimer: undefined
    	},
    	alert: function(content,callback) {
            var alertHtml = '<div id="fullbg"></div>\
                            <div id="dialog-alert">\
                                <p>'+content+'</p>\
                                <a href="javascript:;" class="btn" langext="more">确定</a>\
                            </div>';

            $('body').append(alertHtml);
            $('body').off('click').on('click','#dialog-alert .btn',function(elem){
                $('#fullbg,#dialog-alert').remove();
                if (callback && typeof callback == 'function') {
                    callback();
                }
            });
            multilingual.refreshLang();
        },

        confirm: function(content,okFuc,cancelFuc) {
            var confirmHtml = '<div id="fullbg"></div>\
                                <div id="dialog-alert">\
                                    <p langext="more">'+content+'</p>\
                                    <div class="dialog-confirm">\
                                         <a href="javascript:;" class="btn cancel" langext="more">取消</a>\
                                         <a href="javascript:;" class="btn ok" langext="more">确定</a>\
                                    </div>\
                                </div>';

            $('body').append(confirmHtml).off('click').on('click','#dialog-alert .btn',function(){
                $('#fullbg,#dialog-alert').remove();
            }).on('click','#dialog-alert .ok',function(){
                if (okFuc && typeof okFuc == 'function') {
                    okFuc();
                }
            }).on('click','#dialog-alert .cancel',function(){
                if (cancelFuc && typeof cancelFuc == 'function') {
                    cancelFuc();
                }
            });
            multilingual.refreshLang();
        },

        toast: function(content,top,time) {
            $('#dialog-toast').remove();
            var styleTop = top?('top:'+top):'';
            var time = time?time:2200;
            var toastHtml = '<div id="dialog-toast" style='+styleTop+'>\
                                <span langext="more">'+content+'</span>\
                             </div>';
            $('body').append(toastHtml);
            if(kmDialog.options.toastTimer != undefined){//定时时间内，多次点击造成的定时器混乱
            	clearTimeout(kmDialog.options.toastTimer);
            }
            kmDialog.options.toastTimer = setTimeout(function() {
                $('#dialog-toast').remove();
            },time);
            multilingual.refreshLang();
        },

        loading: function(content,type){//type为1[默认]即全屏，为2不全屏
            var tip = content||'',
                type = (type==1 || type==undefined) ?1:2,
                loadingHtml = "";
            if(type==1){
                loadingHtml += '<div id="loading-mask">';
            }else{
                loadingHtml += '<div id="loading-mask" class="loading-mask">';
            }
            loadingHtml += '<div class="loading-container">\
                                        <div class="loading-icon">\
                                            <div class="loading_leaf loading_leaf_0"></div>\
                                            <div class="loading_leaf loading_leaf_1"></div>\
                                            <div class="loading_leaf loading_leaf_2"></div>\
                                            <div class="loading_leaf loading_leaf_3"></div>\
                                            <div class="loading_leaf loading_leaf_4"></div>\
                                            <div class="loading_leaf loading_leaf_5"></div>\
                                            <div class="loading_leaf loading_leaf_6"></div>\
                                            <div class="loading_leaf loading_leaf_7"></div>\
                                            <div class="loading_leaf loading_leaf_8"></div>\
                                            <div class="loading_leaf loading_leaf_9"></div>\
                                            <div class="loading_leaf loading_leaf_10"></div>\
                                            <div class="loading_leaf loading_leaf_11"></div>\
                                            <p class="loading-content">'+tip+'</p>\
                                        </div>\
                                    </div>\
                                </div>';

            $('body').append(loadingHtml);
        },

        hideLoading: function(){
            $('#loading-mask').remove();
        }
    }

