/* ----------------------------------------------------------------------------- 

  AnyPicker - Customizable Picker for Mobile OS
  Version 2.0.5
  Copyright (c)2016 Curious Solutions LLP
  https://curioussolutions.in/libraries/anypicker/content/license.htm
  See License Information in LICENSE file.

 ----------------------------------------------------------------------------- */
(function() {
    function n(a, b) {
        this.elem = a;
        var c = $.extend(!0, {}, $.AnyPicker.defaults.i18n, $.AnyPicker.i18n[void 0 !== b.lang || null !== b.lang ? b.lang : $.CalenStyle.defaults.lang], b.i18n)
          , d = $.extend(!0, {}, $.AnyPicker.defaults)
          , c = {
            i18n: c
        };
        d.i18n = {};
        b.i18n = {};
        this.setting = $.extend({}, d, b, c);
        this.tmp = $.extend({}, $.AnyPicker.tempDefaults);
        this.tmp.overlayClass = "ap-overlay-" + this.setting.timestamp;
        this.tmp.overlaySelector = "." + this.tmp.overlayClass;
        this.tmp.sOrientation = this._getDeviceOrientation();
        $.CF.compareStrings(this.setting.theme, "iOS") && ($.CF.isValid(b.rowHeight) || (this.setting.rowHeight = 36),
        $.CF.isValid(b.visibleRows) || (this.setting.visibleRows = 5),
        $.CF.isValid(b.viewSections) || (this.setting.viewSections = {
            header: ["cancelButton", "setButton"],
            contentTop: [],
            contentBottom: [],
            footer: []
        }),
        $.AnyPicker.extra.bIsiPad && (this.tmp.bIsiPad = !0),
        this.tmp.bIsiPad && $.CF.compareStrings(this.setting.layout, "popup") && (this.setting.layout = "popover"));
        this.tmp.iExt = Math.floor(this.setting.visibleRows / 2);
        this.tmp.sDir = this.setting.rtl ? "rtl" : "ltr";
        $.CF.isValid(this.setting.components) && 0 === this.tmp.numOfComp && (this.tmp.numOfComp = this.setting.components.length);
        $.AnyPicker.extra.sStartEv = $.AnyPicker.extra.bHasPointer ? $.AnyPicker.extra.bHasIE10Pointer ? "MSPointerDown" : "pointerdown" : $.AnyPicker.extra.bIsTouchDevice ? "touchstart" : "mousedown touchstart";
        $.AnyPicker.extra.sMoveEv = $.AnyPicker.extra.bHasPointer ? $.AnyPicker.extra.bHasIE10Pointer ? "MSPointerMove" : "pointermove" : $.AnyPicker.extra.bIsTouchDevice ? "touchmove" : "mousemove touchmove";
        $.AnyPicker.extra.sEndEv = $.AnyPicker.extra.bHasPointer ? $.AnyPicker.extra.bHasIE10Pointer ? "MSPointerUp" : "pointerup" : $.AnyPicker.extra.bIsTouchDevice ? "touchend" : "mouseup touchend";
        $.AnyPicker.extra.sLeaveEv = $.AnyPicker.extra.bHasPointer ? $.AnyPicker.extra.bHasIE10Pointer ? "MSPointerLeave" : "pointerleave" : $.AnyPicker.extra.bIsTouchDevice ? null : "mouseleave";
        $.AnyPicker.extra.sCancelEv = $.AnyPicker.extra.bHasPointer ? $.AnyPicker.extra.bHasIE10Pointer ? "MSPointerCancel" : "pointercancel" : null;
        $.AnyPicker.extra.sOutEv = $.AnyPicker.extra.bHasPointer ? $.AnyPicker.extra.bHasIE10Pointer ? "MSPointerOut" : "pointerout" : null
    }
    $.CF = {
        setPropertiesStyle: function(a, b) {
            var c = window.getComputedStyle(document.documentElement, ""), d;
            for (d in b)
                if (void 0 !== c[b[d]])
                    return c = "",
                    -1 !== b[d].search("Webkit") && (c = "-webkit-"),
                    c + a
        },
        testProperties: function(a, b, c) {
            a = window.getComputedStyle(document.documentElement, "");
            for (var d in b)
                if (void 0 !== a[b[d]])
                    return c ? b[d] : !0;
            return c ? "" : !1
        },
        compareDataType: function(a, b) {
            return typeof a === b.toLocaleLowerCase() ? !0 : !1
        },
        compareStrings: function(a, b) {
            return null !== a && void 0 !== a && null !== b && void 0 !== b ? "string" === typeof a && "string" === typeof b && a.toLocaleLowerCase() === b.toLocaleLowerCase() ? !0 : !1 : null === a && null === b || void 0 === a && void 0 === b ? !0 : !1
        },
        isValid: function(a) {
            return void 0 !== a && null !== a && "" !== a ? !0 : !1
        }
    };
    $.AnyPicker = $.AnyPicker || {
        name: "AnyPicker",
        version: "2.0.3",
        i18n: {},
        defaults: {
            mode: "select",
            parent: "body",
            layout: "popup",
            hAlign: "left",
            vAlign: "bottom",
            relativeTo: null,
            inputElement: null,
            inputChangeEvent: "onSet",
            lang: "",
            rtl: !1,
            animationDuration: 0,
            setButton: {
                markup: "<a id='ap-button-set' class='ap-button'>\u786e\u5b9a</a>",
                type: "Button"
            },
            cancelButton: {
                markup: "<a id='ap-button-cancel' class='ap-button'>\u53d6\u6d88</a>",
                type: "Button"
            },
            viewSections: {
                contentTop: [],
                contentBottom: [],
                footer: ["cancelButton", "setButton"]
            },
            i18n: {
                setButton: "\u786e\u5b9a",
                clearButton: "Clear",
                cancelButton: "\u53d6\u6d88",
                dateSwitch: "Date",
                timeSwitch: "Time"
            },
            theme: "Default",
            onInit: null,
            onBeforeShowPicker: null,
            onShowPicker: null,
            onBeforeHidePicker: null,
            onHidePicker: null,
            parseInput: null,
            formatOutput: null,
            setOutput: null,
            onSetOutput: null
        },
        tempDefaults: {
            sOrientation: "portrait",
            overlayClass: "",
            overlaySelector: "",
            iExt: 2,
            dir: "ltr",
            sElemTag: "",
            oElemValid: {
                bIsInput: !1,
                bIsListItem: !1,
                bIsSelect: !1
            },
            sInputElemTag: "",
            oInputElemValid: {
                bIsInput: !1,
                bIsListItem: !1,
                bIsSelect: !1
            },
            prevActive: null,
            bFirst: !0,
            sDateTimeTab: "date",
            iCompDragStart: 0,
            headerTitleDefined: !1,
            bIsiPad: !1,
            bModified: {
                set: !1,
                cancel: !1,
                clear: !1,
                now: !1
            },
            tabKey: !1
        },
        extra: {
            sArrModes: ["select"],
            sArrLayout: ["popup", "relative", "fixed", "inline"],
            sArrHAlign: ["left", "center", "right"],
            sArrVAlign: ["top", "middle", "bottom"],
            sArrViewSections: ["header", "contentTop", "contentBottom", "footer"],
            oArrInputChangeEvent: ["onChange", "onSet"],
            sArrThemes: ["Default", "iOS", "Android"],
            bIsTouchDevice: "ontouchstart"in document.documentElement,
            sClickHandler: "click",
            sClickHandlerButtons: "ontouchstart"in document.documentElement ? "touchstart" : "click",
            bHasCSS3D: $.CF.testProperties("perspective", ["WebkitPerspective", "perspective", "perspectiveProperty"], !1),
            sCSSTransform: $.CF.testProperties("transform", ["WebkitTransform", "transform"], !0),
            sCSSTransformStyle: $.CF.setPropertiesStyle("transform", ["WebkitTransform", "transform"]),
            sCSSTransition: $.CF.testProperties("transition", ["WebkitTransition", "transition"], !0),
            bHasCSSAnimation: $.CF.testProperties("animation", ["WebkitAnimation", "animation"], !1),
            sMouseWheel: "onwheel"in document || 9 <= document.documentMode ? ["wheel"] : ["mousewheel", "DomMouseScroll", "MozMousePixelScroll"],
            bHasIE10Pointer: window.navigator.msPointerEnabled && !window.navigator.pointerEnabled,
            bHasPointer: window.navigator.pointerEnabled || window.navigator.msPointerEnabled,
            bIsiPad: null !== navigator.userAgent.match(/iPad/i)
        }
    };
    (function(a) {
        "function" === typeof define && define.amd ? define(["jquery"], a) : "object" === typeof exports ? module.exports = a(require("jquery")) : a(jQuery)
    }
    )(function(a) {
        a.fn.AnyPicker = function(b) {
            var c = a(this).data(), d = Object.keys(c), e, f;
            if (null === b || void 0 === b)
                if (0 < d.length)
                    for (e in d) {
                        if (f = d[e],
                        -1 !== f.search("plugin_AnyPicker_"))
                            return c[f]
                    }
                else
                    console.log("No AnyPicker Object Defined For This Element");
            else if ("string" === typeof b) {
                if (null !== c || void 0 !== c)
                    if (0 < d.length) {
                        if ("destroy" === b)
                            if (0 < d.length)
                                for (e in d) {
                                    if (f = d[e],
                                    -1 !== f.search("plugin_AnyPicker_")) {
                                        c = c[f];
                                        a(window).off("blur." + c.setting.timestamp);
                                        var g = a(c.setting.inputElement);
                                        a(g).off("focus." + c.setting.timestamp);
                                        a(g).off("blur." + c.setting.timestamp);
                                        a(".ap-overlay-" + f.replace("plugin_AnyPicker_", "")).remove();
                                        a(this).removeData(f);
                                        break
                                    }
                                }
                            else
                                console.log("No AnyPicker Object Defined For This Element")
                    } else
                        console.log("No AnyPicker Object Defined For This Element")
            } else
                return this.each(function() {
                    var g = (new Date).getTime();
                    if (a.data(this, "plugin_AnyPicker_" + g))
                        if (0 < d.length)
                            for (e in d) {
                                if (f = d[e],
                                -1 !== f.search("plugin_AnyPicker_"))
                                    return c[f]
                            }
                        else
                            console.log("No AnyPicker Object Defined For This Element");
                    else
                        b.timestamp = g,
                        c = new n(this,b),
                        a.data(this, "plugin_AnyPicker_" + g, c),
                        c.init()
                })
        }
    });
    n.prototype = {
        init: function() {
            var a = this;
            $.CF.isValid(a.elem) && (a.tmp.sElemTag = $(a.elem).prop("tagName").toLowerCase(),
            "input" === a.tmp.sElemTag ? a.tmp.oElemValid.bIsInput = !0 : "ul" === a.tmp.sElemTag || "ol" === a.tmp.sElemTag || "dl" === a.tmp.sElemTag ? a.tmp.oElemValid.bIsListItem = !0 : "select" === a.tmp.sElemTag && (a.tmp.oElemValid.bIsSelect = !0));
            $.CF.isValid(a.setting.inputElement) ? (a.tmp.sInputElemTag = $(a.setting.inputElement).prop("tagName").toLowerCase(),
            "input" === a.tmp.sInputElemTag ? a.tmp.oInputElemValid.bIsInput = !0 : "ul" === a.tmp.sInputElemTag || "ol" === a.tmp.sInputElemTag || "dl" === a.tmp.sInputElemTag ? a.tmp.oInputElemValid.bIsListItem = !0 : "select" === a.tmp.sInputElemTag && (a.tmp.oInputElemValid.bIsSelect = !0)) : $.CF.isValid(a.elem) && (a.setting.inputElement = a.elem,
            a.tmp.sInputElemTag = a.tmp.sElemTag,
            a.tmp.oInputElemValid = a.tmp.oElemValid);
            $.CF.compareStrings(a.setting.mode, "select") && a.__setComponentsOfSelect();
            if ("" !== a.tmp.sInputElemTag && !a.tmp.oInputElemValid.bIsListItem && !a.tmp.oInputElemValid.bIsSelect) {
                var b = $(a.setting.inputElement);
                a.tmp.oInputElemValid.bIsInput ? (b.off("focus." + a.setting.timestamp),
                b.off("click").on("click." + a.setting.timestamp, {
                    apo: a
                }, a._inputElementClicked),
                b.on("blur." + a.setting.timestamp, function(b) {
                    $.AnyPicker.tempDefaults.tabKey && a.showOrHidePicker();
                    a.tmp.prevActive = null
                }),
                b.on("keydown." + a.setting.timestamp, function(a) {
                    "9" === (a.keyCode ? a.keyCode : a.which) && ($.AnyPicker.tempDefaults.tabKey = !0)
                })) : (b.off("click." + a.setting.timestamp),
                b.on("click." + a.setting.timestamp, {
                    apo: a
                }, a._inputElementClicked))
            }
            $.CF.isValid(a.setting.onInit) && a.setting.onInit.call(a)
        },
        _inputElementClicked: function(a) {
            a.stopPropagation();
            a.preventDefault();
            var b = a.data.apo;
            if (document.activeElement !== b.tmp.prevActive || document.activeElement !== b.setting.inputElement)
                if (b.tmp.prevActive = document.activeElement,
                "" === b.tmp.sInputElemTag || b.tmp.oInputElemValid.bIsListItem || b.tmp.oInputElemValid.bIsSelect)
                    console.log("No InputElement Specified");
                else {
                    a = $(b.setting.inputElement);
                    var c;
                    if (b.tmp.oInputElemValid.bIsInput)
                        c = a.val();
                    else {
                        var d = a.attr("data-val");
                        c = $.CF.isValid(d) ? d : a.text()
                    }
                    $.AnyPicker.tempDefaults.tabKey ? ($.AnyPicker.tempDefaults.tabKey = !1,
                    setTimeout(function() {
                        b.showOrHidePicker(c)
                    }, 500)) : b.showOrHidePicker(c)
                }
        },
        showOrHidePicker: function(a) {
            var b, c, d = [], e = [];
            if (void 0 !== a && null !== a)
                if ($.CF.isValid(this.setting.parseInput)) {
                    if ($.CF.compareStrings(this.setting.mode, "select")) {
                        d = this.setting.parseInput.call(this, a);
                        for (a = 0; a < d.length; a++)
                            b = d[a],
                            c = this.__getDataSourceValueFromLabel(b, a, !0),
                            e.push({
                                component: a,
                                val: c,
                                label: b
                            });
                        this.tmp.selectedValues.values = e
                    }
                } else if ($.CF.compareStrings(this.setting.mode, "select")) {
                    if ("" !== a)
                        for (d = [],
                        e = [],
                        1 < this.tmp.numOfComp ? d = a.split(" ") : d.push(a),
                        a = 0; a < d.length; a++)
                            b = d[a],
                            c = this.__getDataSourceValueFromLabel(b, a, !0),
                            e.push({
                                component: a,
                                val: c,
                                label: b
                            });
                    else
                        for (a = 0; a < this.tmp.numOfComp; a++)
                            d = this.setting.dataSource[a].data,
                            b = d[0].label,
                            c = d[0].val,
                            e.push({
                                component: a,
                                val: c,
                                label: b
                            });
                    this.tmp.selectedValues.values = e
                }
            0 < $(this.tmp.overlaySelector).length ? this._hidePicker() : this._showPicker()
        },
        _showPicker: function() {
            var a = this;
            a.tmp.sOrientation = a._getDeviceOrientation();
            $.CF.isValid(a.setting.onBeforeShowPicker) && a.setting.onBeforeShowPicker.call(a);
            var b = ""
              , c = ($.CF.compareStrings(a.setting.layout, "popup") || $.CF.compareStrings(a.setting.layout, "popover")) && 0 < a.setting.viewSections.header.length
              , d = ($.CF.compareStrings(a.setting.layout, "popup") || $.CF.compareStrings(a.setting.layout, "popover")) && 0 < a.setting.viewSections.footer.length
              , e = $.CF.compareStrings(a.setting.layout, "fixed") && $.CF.compareStrings(a.setting.vAlign, "bottom") && 0 < a.setting.viewSections.footer.length
              , f = $.CF.compareStrings(a.setting.layout, "fixed") && $.CF.compareStrings(a.setting.vAlign, "top") && 0 < a.setting.viewSections.footer.length
              , g = "ap-layout-" + a.setting.layout
              , k = "ap-theme-" + a.setting.theme.toLowerCase()
              , l = "ap-dir-" + a.tmp.sDir;
            if ($.CF.compareStrings(a.setting.layout, "popover")) {
                var h = $("body").scrollTop()
                  , m = $(window).height()
                  , m = h + m
                  , p = $.CF.compareStrings(a.setting.rowsNavigation, "scroller") ? 300 : 350
                  , h = $(a.setting.inputElement).offset().top - p < h ? !1 : !0
                  , m = $(a.setting.inputElement).offset().top + $(a.setting.inputElement).height() + p > m ? !1 : !0;
                a.tmp.sTooltip = m ? "bottom" : h ? "top" : a.setting.rtl ? "right" : "left"
            }
            b += "<div class='ap-overlay " + g + " " + a.tmp.overlayClass + " " + k + " " + l + "'>";
            b = b + "<div class='ap-bg'>" + ("<div class='ap-cont' dir='" + a.tmp.sDir + "'>");
            $.CF.isValid(a.tmp.sTooltip) && (b += "<span class='ap-tooltip ap-tooltip-" + a.tmp.sTooltip + "'></span>");
            c && (b += "<div class='ap-header'>",
            b += "</div>");
            e && (b += "<div class='ap-footer ap-footer-top'>",
            $.CF.compareStrings(a.setting.theme, "Default") && (b += "<div class='ap-button-cont'></div>"),
            b += "</div>");
            b += "<div class='ap-content'>";
            0 < a.setting.viewSections.contentTop.length && (b += "<div class='ap-content-top'></div>");
            b += "<div class='ap-content-middle'>";
            b += "<div class='ap-component-section'></div>";
            b += "</div>";
            0 < a.setting.viewSections.contentBottom.length && (b += "<div class='ap-content-bottom'></div>");
            b += "</div>";
            if (d || f)
                b += "<div class='ap-footer ap-footer-bottom'>",
                $.CF.compareStrings(a.setting.theme, "Default") && (b += "<div class='ap-button-cont'></div>"),
                b += "</div>";
            b += "</div>";
            b += "</div>";
            b += "</div>";
            $(a.setting.parent).append(b);
            "popover" === a.setting.layout && $("body").addClass("noscroll");
            $.AnyPicker.extra.bHasCSSAnimation ? ($(a.tmp.overlaySelector).css({
                display: "block"
            }),
            $.CF.compareStrings(a.setting.layout, "fixed") && ($.CF.compareStrings(a.setting.vAlign, "top") ? $(a.tmp.overlaySelector).find(".ap-cont").addClass("ap-top-slide-down") : $.CF.compareStrings(a.setting.vAlign, "bottom") && $(a.tmp.overlaySelector).find(".ap-cont").addClass("ap-bottom-slide-up")),
            setTimeout(function() {
                $(a.tmp.overlaySelector).css({
                    opacity: 1
                });
                $.CF.compareStrings(a.setting.layout, "fixed") && ($.CF.compareStrings(a.setting.vAlign, "top") ? ($(a.tmp.overlaySelector).find(".ap-cont").removeClass("ap-top-slide-down"),
                $(a.tmp.overlaySelector + " .ap-cont").css({
                    top: 0
                })) : $.CF.compareStrings(a.setting.vAlign, "bottom") && ($(a.tmp.overlaySelector).find(".ap-cont").removeClass("ap-bottom-slide-up"),
                $(a.tmp.overlaySelector + " .ap-cont").css({
                    bottom: 0
                })))
            }, a.setting.animationDuration)) : $(a.tmp.overlaySelector).show(0);
            $.CF.isValid(a.setting.onShowPicker) && a.setting.onShowPicker.call(a);
            a._adjustPicker();
            a._addViewSectionComponents();
            a.__initComponents();
            a._adjustPicker()
        },
        _hidePicker: function() {
            var a = this;
            0 < $(a.tmp.overlaySelector).length && ($.CF.isValid(a.setting.onBeforeHidePicker) && a.setting.onBeforeHidePicker.call(a),
            $.AnyPicker.extra.bHasCSSAnimation ? $.CF.compareStrings(a.setting.layout, "fixed") && ($.CF.compareStrings(a.setting.vAlign, "top") ? $(a.tmp.overlaySelector).find(".ap-cont").addClass("ap-top-slide-up") : $.CF.compareStrings(a.setting.vAlign, "bottom") && $(a.tmp.overlaySelector).find(".ap-cont").addClass("ap-bottom-slide-down")) : $(a.tmp.overlaySelector).hide(0),
            setTimeout(function() {
                $(a.tmp.overlaySelector).remove()
            }, a.setting.animationDuration),
            "popover" === a.setting.layout && $("body").removeClass("noscroll"),
            a.tmp.prevActive = null,
            $.CF.isValid(a.setting.onHidePicker) && a.setting.onHidePicker.call(a))
        },
        _adjustPicker: function(a) {
            var b = $(null === this.setting.relativeTo ? this.setting.inputElement : this.setting.relativeTo);
            a = b.offset().top;
            var c = b.offset().left
              , d = b.outerWidth();
            if ($.CF.compareStrings(this.setting.layout, "popover")) {
                a = $("body").scrollTop();
                $(window).outerWidth();
                $(window).outerHeight();
                var c = $(this.setting.inputElement).offset().top - a, d = $(this.setting.inputElement).outerHeight(), b = c + d, e = $(this.setting.inputElement).offset().left, f = $(this.setting.inputElement).outerWidth(), g = e + f, k = $(this.tmp.overlaySelector).find(".ap-cont").outerWidth(), l = $(this.tmp.overlaySelector).find(".ap-cont").outerHeight(), h, m;
                "top" === this.tmp.sTooltip ? (h = c - l - 10,
                m = e + 5) : "bottom" === this.tmp.sTooltip ? (h = b + 10,
                m = e + 5,
                "rtl" === this.tmp.sDir && (m = g - k)) : "left" === this.tmp.sTooltip ? (h = c - (l / 2 - d / 2),
                h = h < a ? 5 : h,
                m = e + f + 5) : "right" === this.tmp.sTooltip && (h = c - (l / 2 - d / 2),
                h = h < a ? 5 : h,
                m = e - (k + 10));
                $(this.tmp.overlaySelector).find(".ap-cont").css({
                    position: "absolute",
                    left: m,
                    top: h
                })
            } else
                $.CF.compareStrings(this.setting.layout, "inline") ? $(this.tmp.overlaySelector).find(".ap-cont").css({
                    position: "absolute",
                    width: d,
                    left: c,
                    top: a
                }) : $.CF.compareStrings(this.setting.layout, "relative") ? (b = $(null === this.setting.relativeTo ? this.setting.inputElement : this.setting.relativeTo),
                h = $(document).outerWidth(),
                m = $(".ap-cont").outerWidth(),
                e = d,
                d = e > m ? m : e,
                a += b.outerHeight(),
                $.CF.compareStrings(this.setting.hAlign, "center") ? c = e > d ? c + d / 2 : e === d ? c : c - d / 2 : $.CF.compareStrings(this.setting.hAlign, "right") && (c -= d),
                c = 0 > c ? 5 : c,
                m = c + d,
                m > h && (5 < c ? (c -= m - (h + 5),
                c = 0 > c ? 5 : c,
                d = c + d > h ? h - 10 : d) : d = h - 10),
                $(this.tmp.overlaySelector).find(".ap-cont").css({
                    position: "absolute",
                    "min-width": d,
                    left: c,
                    top: a
                })) : $.CF.compareStrings(this.setting.layout, "fixed") && ($.CF.compareStrings(this.setting.vAlign, "top") ? $(this.tmp.overlaySelector + " .ap-cont").css({
                    top: -1E3
                }) : $.CF.compareStrings(this.setting.vAlign, "bottom") && $(this.tmp.overlaySelector + " .ap-cont").css({
                    bottom: -1E3
                }))
        },
        _addViewSectionComponents: function() {
            var a = this, b, c;
            for (b = 0; b < $.AnyPicker.extra.sArrViewSections.length; b++) {
                var d = $.AnyPicker.extra.sArrViewSections[b]
                  , e = a.setting.viewSections[d];
                if (0 < e.length)
                    for (c = 0; c < e.length; c++) {
                        var f = e[c]
                          , g = a.setting[f] || null
                          , k = $(g.markup);
                        if (void 0 !== g && null !== g && "" !== g) {
                            if ($.CF.compareStrings(d, "header")) {
                                if ($(a.tmp.overlaySelector).find(".ap-header").append(k),
                                $.CF.compareStrings(g.type, "Button") && $.CF.compareDataType(g.action, "function"))
                                    k.on("click." + a.setting.timestamp, {
                                        apo: a
                                    }, g.action)
                            } else if ($.CF.compareStrings(d, "contentTop")) {
                                if ($(a.tmp.overlaySelector).find(".ap-content-top").append(k),
                                $.CF.compareStrings(g.type, "Button") && $.CF.compareDataType(g.action, "function"))
                                    k.on("click." + a.setting.timestamp, {
                                        apo: a
                                    }, g.action)
                            } else if ($.CF.compareStrings(d, "contentBottom")) {
                                if ($(a.tmp.overlaySelector).find(".ap-content-bottom").append(k),
                                $.CF.compareStrings(g.type, "Button") && $.CF.compareDataType(g.action, "function"))
                                    k.on("click." + a.setting.timestamp, {
                                        apo: a
                                    }, g.action)
                            } else if ($.CF.compareStrings(d, "footer")) {
                                var l = $(a.tmp.overlaySelector).find(".ap-button-cont");
                                0 < l.length ? l.append(k) : $(a.tmp.overlaySelector).find(".ap-footer").append(k);
                                if ($.CF.compareStrings(g.type, "Button") && $.CF.compareDataType(g.action, "function"))
                                    k.on("click." + a.setting.timestamp, {
                                        apo: a
                                    }, g.action)
                            }
                            $.CF.compareStrings(f, "setButton") ? a.tmp.bModified.set ? k.text(a.setting.i18n.setButton) : a.tmp.bModified.set || k.find(".ap-button-text").text(a.setting.i18n.setButton) : $.CF.compareStrings(f, "cancelButton") && (a.tmp.bModified.cancel ? k.text(a.setting.i18n.cancelButton) : a.tmp.bModified.cancel || k.find(".ap-button-text").text(a.setting.i18n.cancelButton));
                            if ($.CF.compareStrings(g.type, "Button") && !$.CF.compareDataType(g.action, "function"))
                                if ($.CF.compareStrings(f, "setButton"))
                                    k.on("click." + a.setting.timestamp, {
                                        apo: a
                                    }, a._setButtonAction);
                                else if ($.CF.compareStrings(f, "cancelButton"))
                                    k.on("click." + a.setting.timestamp, {
                                        apo: a
                                    }, a._cancelButtonAction)
                        }
                    }
            }
            $(a.tmp.overlaySelector).find(".ap-button").on("mousedown touchstart", function(a) {
                $(this).addClass("ap-button-active")
            }).on("mouseup touchend", function(a) {
                $(this).removeClass("ap-button-active")
            });
            $(window).on("blur." + a.setting.timestamp, function(b) {
                a.tmp.prevActive = document.activeElement
            });
            $(a.tmp.overlaySelector).off("click." + a.setting.timestamp);
            setTimeout(function() {
                $(a.tmp.overlaySelector).on("click." + a.setting.timestamp, function(b) {
                    b = Date.now() - a.tmp.iCompDragStart;
                    !a.setting.bIsTouched && 1E3 < b && a._hidePicker()
                })
            }, 300);
            $(a.tmp.overlaySelector).find(".ap-cont, .ap-cont *").on("click." + a.setting.timestamp, function(a) {
                a.stopPropagation()
            })
        },
        _setOutput: function() {
            var a = this
              , b = "";
            if ($.CF.isValid(a.setting.formatOutput))
                b = a.setting.formatOutput.call(a, a.tmp.selectedValues);
            else if ($.CF.compareStrings(a.setting.mode, "select"))
                for (var c = 0; c < a.tmp.numOfComp; c++)
                    0 !== c && (b += " "),
                    b += a.tmp.selectedValues.values[c].label;
            if (a.tmp.oElemValid.bIsListItem || a.tmp.oElemValid.bIsSelect) {
                var d, e;
                a.tmp.oElemValid.bIsListItem ? d = "li" : a.tmp.oElemValid.bIsSelect && (d = "option");
                $(a.elem).find(d).each(function() {
                    e = $(this);
                    var b = e.attr("value") || e.data("value") || e.text();
                    a.tmp.selectedValues.values[0].val === b ? a.tmp.oElemValid.bIsSelect && e.attr("selected", !0) : a.tmp.oElemValid.bIsSelect && e.attr("selected", !1)
                })
            }
            $.CF.isValid(a.setting.setOutput) ? a.setting.setOutput.call(a, b, a.tmp.selectedValues) : (null !== a.setting.inputElement && (c = $(a.setting.inputElement),
            a.tmp.oInputElemValid.bIsInput ? (c.attr("data-value", $(".ap-row-selected").attr("data-value")),
          //  c.attr("data-url", $(".ap-row-selected").attr("data-url")),
            c.val(b)) : c.text(b)),
            $.CF.isValid(a.setting.onSetOutput) && a.setting.onSetOutput.call(a, b, a.tmp.selectedValues))
        },
        _clearOutput: function() {
            var a = $(this.setting.inputElement);
            this.tmp.oInputElemValid.bIsInput ? a.val("") : a.text("")
        },
        _setButtonAction: function(a) {
            a = a.data.apo;
            a._setOutput();
            a.showOrHidePicker()
        },
        _cancelButtonAction: function(a) {
            a.data.apo.showOrHidePicker()
        },
        _getDeviceOrientation: function() {
            var a = $(window);
            return a.width() > a.height() ? "landscape" : "portrait"
        }
    };
    $.AnyPicker = $.extend(!0, $.AnyPicker, {
        defaults: {
            components: null,
            dataSource: null,
            showComponentLabel: !1,
            componentsCoverFullWidth: !1,
            visibleRows: 3,
            maxRows: 0,
            rowHeight: 50,
            rowsNavigation: "scroller",
            rowView: null,
            onChange: null
        },
        tempDefaults: {
            numOfComp: 0,
            selectedValues: {},
            bIsManualDragging: !1,
            bIsTouched: !1,
            iTS: 0,
            iPos: 0,
            iPosPrev: 0,
            iPosStop: 0,
            iOffset: 0,
            iOffsetPrev: 0,
            iVelocity: 0,
            iAmplitude: 0,
            oVelocityTicker: null,
            oScrollTicker: null,
            iMinTopPos: 0,
            iMaxTopPos: 0,
            oScrollingComp: null,
            iScrollingComp: -1,
            iTmConst: 100,
            bEnd: !1
        },
        extra: {
            sArrRowsNavigation: ["scroller+buttons", "scroller", "buttons"]
        }
    });
    n.prototype = $.extend(n.prototype, {
        __initComponents: function() {
            this.tmp.bFirst ? this.tmp.bFirst = !1 : $.CF.compareStrings(this.setting.mode, "select") && this.__setComponentsOfSelect();
            0 < (this.tmp.numOfComp || this.setting.components.length) && (0 < this.setting.components.length ? this.reloadAllComponents() : console.log("For apo.setting.mode \n 1. Select - \n Please set apo.setting.components 2. DateTime - \n Please enter a valid outputDateTimeFormat "))
        },
        reloadAllComponents: function() {
            var a;
            $(this.setting.parent).find(".ap-component-section").html("");
            $("body").prepend("<div class='ap-loading'></div>");
            for (a = 0; a < this.tmp.numOfComp; a++)
                this.reloadComponent(a, !1);
            this.adjustComponents();
            this.setSelectedAndInvalidValuesForRows(!0)
        },
        reloadComponent: function(a, b) {
            var c = "", d, e = this.setting.dataSource[a].data, f = !1, g;
            d = "ap-component-" + a;
            var k = $(this.setting.parent).find("#" + d)
              , f = this.setting.components[a];
            g = $.CF.isValid(f.type) ? f.type : f.label;
            var l = $.CF.isValid(f.width) ? "width: " + f.width : ""
              , h = this.setting.rtl ? $.CF.compareStrings(f.textAlign, "left") ? "right" : $.CF.compareStrings(f.textAlign, "right") ? "left" : "" : f.textAlign
              , h = $.CF.isValid(h) ? "text-align: " + h : "";
            0 === k.length && (c += "<div class='ap-component' id='" + d + "' data-type='" + g + "' " + ("" !== l ? "style='" + l + ";'" : "") + ">");
            if ($.CF.compareStrings(this.setting.rowsNavigation, "scroller+buttons") || $.CF.compareStrings(this.setting.rowsNavigation, "buttons"))
                c += "<div class='ap-component-plus ap-icon-arrow-up-filled' " + ("" !== h ? "style='" + h + ";'" : "") + "></div>";
            c = c + "<div class='ap-component-cont' tabindex='0'>" + ("<div class='ap-component-data' role='listbox' aria-label='" + f.label + "'>");
            for (d = 0; d < this.tmp.iExt; d++)
                c += "<div class='ap-row ap-row-ext'></div>";
            for (d = 0; d < e.length; d++)
                g = (f = $.CF.isValid(e[d].selected) ? e[d].selected : !1) ? "ap-row-selected" : "",
                c += "<div class='ap-row " + g + "' id='ap-row-" + a + "-" + d + "' data-value='" + e[d].val + "' data-label='" + e[d].label + "'  role='option' aria-selected='" + f + "' " + ("" !== h ? "style='" + h + ";'" : "") + ">",
                c = $.CF.isValid(this.setting.rowView) ? c + this.setting.rowView.call(this, a, d, e[d]) : c + e[d].label,
                c += "</div>";
            for (d = 0; d < this.tmp.iExt; d++)
                c += "<div class='ap-row ap-row-ext'></div>";
            c += "</div>";
            c += "<div class='ap-component-gradient'></div>";
            c += "<div class='ap-component-selector' id='ap-component-selector-" + a + "'></div>";
            c += "</div>";
            if ($.CF.compareStrings(this.setting.rowsNavigation, "scroller+buttons") || $.CF.compareStrings(this.setting.rowsNavigation, "buttons"))
                c += "<div class='ap-component-minus ap-icon-arrow-down-filled' " + ("" !== h ? "style='" + h + ";'" : "") + "></div>";
            0 === k.length && (c += "</div>");
            0 < k.length ? k.html(c) : $(this.setting.parent).find(".ap-component-section").append(c);
            this._bindEventsToComponent(a);
            (0 < k.length || b) && this.adjustComponents();
            b && this.setSelectedAndInvalidValuesForRows(!0)
        },
        _bindEventsToComponent: function(a) {
            var b = $("#ap-component-" + a)
              , c = b.find(".ap-component-cont");
            a = {
                component: a,
                apo: this
            };
            if ($.CF.compareStrings(this.setting.rowsNavigation, "scroller+buttons") || $.CF.compareStrings(this.setting.rowsNavigation, "scroller")) {
                c.on($.AnyPicker.extra.sStartEv + "." + this.setting.timestamp, a, this._onStartDrag);
                c.on($.AnyPicker.extra.sMoveEv + "." + this.setting.timestamp, a, this._onDrag);
                if ($.CF.isValid($.AnyPicker.extra.sEndEv))
                    c.on($.AnyPicker.extra.sEndEv + "." + this.setting.timestamp, a, this._onEndDrag);
                if ($.CF.isValid($.AnyPicker.extra.sOutEv))
                    c.on($.AnyPicker.extra.sOutEv + "." + this.setting.timestamp, a, this._onEndDrag);
                if (0 < $.AnyPicker.extra.sMouseWheel.length)
                    for (var d = 0; d < $.AnyPicker.extra.sMouseWheel.length; d++)
                        c.on($.AnyPicker.extra.sMouseWheel[d] + "." + this.setting.timestamp, a, this._onMouseWheelScroll)
            }
            if ($.CF.compareStrings(this.setting.rowsNavigation, "scroller+buttons") || $.CF.compareStrings(this.setting.rowsNavigation, "buttons"))
                b.find(".ap-component-plus").on("click." + this.setting.timestamp, a, this._onClickButtonMinus),
                b.find(".ap-component-minus").on("click." + this.setting.timestamp, a, this._onClickButtonPlus)
        },
        adjustComponents: function() {
            var a = $(this.tmp.overlaySelector);
            a.find(".ap-component-cont").css({
                height: this.setting.rowHeight * this.setting.visibleRows
            });
            a.find(".ap-row, .ap-component-selector").css({
                height: this.setting.rowHeight,
                "line-height": this.setting.rowHeight + "px"
            });
            a.find(".ap-row-bg").css({
                height: this.setting.rowHeight - 8
            });
            setTimeout(function() {
                $(".ap-loading").remove()
            }, 0)
        },
        _onStartDrag: function(a) {
            var b = a.data.apo;
            b.tmp.bIsManualDragging || (b.tmp.bIsManualDragging = !0);
            b.tmp.bIsTouched = !0;
            b.tmp.bEnd = !1;
            b.tmp.iPos = b._getTouchPosition(a);
            b.tmp.bFromTouchStart = !0;
            b._setScrollingData(a);
            "mousedown" === a.type && ($(document).on("mousemove." + b.setting.timestamp, a.data, b._onDrag),
            $(document).on("mouseup." + b.setting.timestamp, a.data, b._onEndDrag));
            a.preventDefault();
            a.stopPropagation();
            return !1
        },
        _onDrag: function(a) {
            var b = a.data.apo, c, d, e, f, g;
            e = Date.now();
            b._clearScrollTicker();
            if (b.tmp.bIsTouched && (!$.AnyPicker.extra.bHasPointer || $.AnyPicker.extra.bHasPointer && (b.tmp.bFromTouchStart || !b.tmp.bFromTouchStart && 1E3 < e - b.tmp.iTS)) && (c = b._getTouchPosition(a),
            e = Date.now(),
            d = b.tmp.iPos - c,
            f = d / Math.abs(d),
            2 < d || -2 > d)) {
                b.tmp.iPosPrev = b.tmp.iPos;
                b.tmp.iPos = c;
                c = e - b.tmp.iTS;
                b.tmp.iTS = e;
                e = d / c;
                b.tmp.iTotalDS += d;
                g = b.tmp.iPrevDSTS - e;
                if ($.AnyPicker.extra.bHasPointer)
                    if ($.AnyPicker.extra.bIsTouchDevice)
                        if (10 < d || -10 > d)
                            if ($.CF.compareStrings(b.setting.theme, "iOS"))
                                d = 4 * b.setting.visibleRows * e;
                            else if (100 < Math.abs(b.tmp.iTotalDS))
                                d = .05 < e ? d * c * 2 : 1 === f ? f * b.setting.rowHeight / 2 : f * b.setting.rowHeight / 1.2;
                            else if (.06 < e && .08 < Math.abs(g))
                                d = d * c * 2;
                            else {
                                if (50 < d || -50 > d)
                                    d = d * c * 2
                            }
                        else
                            d = .06 < Math.abs(e) && .08 < Math.abs(g) ? $.CF.compareStrings(b.setting.theme, "Windows") ? d * c * 5 : d * c * 2 : 1 === f ? f * b.setting.rowHeight / 2 : f * b.setting.rowHeight / 1.2;
                    else
                        2 > d && -2 < d && 0 !== d && (d = 5 * f),
                        d = 5 < d || -5 > d ? b.setting.visibleRows / 10 * 320 * e : f * b.setting.rowHeight;
                else if (10 < d || -10 > d)
                    d += 16 * b.setting.visibleRows * e;
                b.tmp.iPrevDSTS = e;
                b._scrollToPosition("drag", b.tmp.iOffset + d, !1, "#ap-component-" + b.tmp.iScrollingComp + " .ap-component-data");
                b.tmp.bFromTouchStart = !1
            }
            a.preventDefault();
            a.stopPropagation();
            return !1
        },
        _onEndDrag: function(a) {
            var b = a.data.apo;
            b.tmp.bEnd || (b.tmp.bEnd = !0,
            b.tmp.bIsTouched = !1,
            b._scrollToPosition("drag", b.tmp.iOffset, !0, "#ap-component-" + b.tmp.iScrollingComp + " .ap-component-data"),
            "mouseup" === a.type && ($(document).off("mousemove." + b.setting.timestamp, b._onDrag),
            $(document).off("mouseup." + b.setting.timestamp, b._onEndDrag)));
            a.preventDefault();
            a.stopPropagation();
            return !1
        },
        _onMouseWheelScroll: function(a) {
            var b = a.data.apo
              , c = a.data;
            a = a || window.event;
            c.component !== b.tmp.iScrollingComp && b._setScrollingData(a);
            b._clearScrollTicker();
            b._scrollToPosition("mouseWheel", b.tmp.iOffset - (a.wheelDelta ? a.wheelDelta / 3 : a.originalEvent.wheelDelta ? a.originalEvent.wheelDelta / 3 : a.detail ? -a.detail / 3 : 0), !0, "#ap-component-" + b.tmp.iScrollingComp + " .ap-component-data");
            a.preventDefault();
            a.stopPropagation();
            return !1
        },
        _onClickButtonPlus: function(a) {
            var b = a.data.apo;
            a.preventDefault();
            a.stopPropagation();
            b._setScrollingData(a);
            b._clearScrollTicker();
            b._scrollToPosition("button", b.tmp.iOffset + b.setting.rowHeight, !0, "#ap-component-" + b.tmp.iScrollingComp + " .ap-component-data")
        },
        _onClickButtonMinus: function(a) {
            var b = a.data.apo;
            a.preventDefault();
            a.stopPropagation();
            b._setScrollingData(a);
            b._clearScrollTicker();
            b._scrollToPosition("button", b.tmp.iOffset - b.setting.rowHeight, !0, "#ap-component-" + b.tmp.iScrollingComp + " .ap-component-data")
        },
        _getTouchPosition: function(a) {
            a = a.originalEvent || a;
            return a.changedTouches ? a.changedTouches[0].pageY : a.pageY
        },
        _setScrollingData: function(a) {
            var b = a.data.apo;
            b.tmp.iScrollingComp = parseInt(a.data.component);
            b.tmp.oScrollingComp = $("#ap-component-" + a.data.component).find(".ap-component-data");
            b.tmp.iMinTopPos = 0;
            b.tmp.iMaxTopPos = $(b.tmp.oScrollingComp).find(".ap-row").length * b.setting.rowHeight - $(b.tmp.oScrollingComp).parent().innerHeight();
            b.tmp.iTS = Date.now();
            b.tmp.iCompDragStart = b.tmp.iTS;
            b.tmp.iOffsetStart = Math.abs($(b.tmp.oScrollingComp).position().top);
            b.tmp.iOffset = b.tmp.iOffsetStart;
            b.tmp.iOffsetPrev = b.tmp.iOffsetStart;
            b.tmp.iTimeout = 0;
            b.tmp.iDir = 1;
            b.tmp.iTotalDS = 0;
            b.tmp.iPrevDSTS = 0;
            b._clearScrollTicker()
        },
        _unsetScrollingData: function() {
            this.tmp.bIsTouched = !1;
            this.tmp.iPos = 0;
            this.tmp.iTS = 0;
            this.tmp.iOffset = 0;
            this.tmp.iTimeout = 0;
            this.tmp.iMinTopPos = 0;
            this.tmp.iMaxTopPos = 0;
            this.tmp.oScrollingComp = null;
            this.tmp.iScrollingComp = -1;
            this.tmp.iDir = 0;
            this._clearScrollTicker();
            $(document).off("mousemove." + this.setting.timestamp);
            $(document).off("mouseup." + this.setting.timestamp);
            $(document).off("touchend." + this.setting.timestamp)
        },
        _getScrollingData: function() {
            var a = {};
            a.iScrollingComp = this.tmp.iScrollingComp;
            a.oScrollingComp = this.tmp.oScrollingComp;
            a.iMinTopPos = this.tmp.iMinTopPos;
            a.iMaxTopPos = this.tmp.iMaxTopPos;
            a.iTS = this.tmp.iTS;
            a.iCompDragStart = this.tmp.iCompDragStart;
            a.iOffsetStart = this.tmp.iOffsetStart;
            a.iOffset = this.tmp.iOffset;
            a.iOffsetPrev = this.tmp.iOffsetPrev;
            a.iTimeout = this.tmp.iTimeout;
            a.iDir = this.tmp.iDir;
            return a
        },
        _clearScrollTicker: function() {
            clearTimeout(this.tmp.oScrollTicker);
            this.tmp.oScrollTicker = null
        },
        _scrollToPosition: function(a, b, c, d) {
            var e = this.tmp.iScrollingComp
              , f = b < this.tmp.iOffset ? 1 : b === this.tmp.iOffset ? this.tmp.iDir : -1
              , g = b % this.setting.rowHeight
              , k = this.setting.rowHeight / 4
              , l = this.tmp.iOffset
              , h = .1;
            this.tmp.iDir = f;
            c && (b = 0 !== g ? g < k ? b - g : b + (this.setting.rowHeight - g) : b);
            g = this.tmp.iMinTopPos - this.setting.rowHeight;
            k = this.tmp.iMaxTopPos + this.setting.rowHeight;
            this.tmp.iOffset = b > this.tmp.iMaxTopPos ? k : b < this.tmp.iMinTopPos ? g : b;
            $.AnyPicker.extra.bHasCSS3D ? (b = Math.abs(l - this.tmp.iOffset),
            "drag" === a ? b < 6 * this.setting.rowHeight ? h = b / (10 * this.setting.rowHeight) : (h = b / (10 * this.setting.rowHeight),
            h = .2 >= h ? .2 : h) : h = .1,
            this._performTransition(e, d, this.tmp.iOffset, this.tmp.iTimeout / 1E3, this.tmp.iMinTopPos, this.tmp.iMaxTopPos, f, g, k, a, c),
            this.tmp.iTimeout = this.tmp.iTimeout - (Date.now() - this.tmp.iTS) + 1E3 * h) : this._performTransition(e, d, this.tmp.iOffset, h, this.tmp.iMinTopPos, this.tmp.iMaxTopPos, f, g, k, a, c)
        },
        _performTransition: function(a, b, c, d, e, f, g, k, l, h, m) {
            a = $(this.tmp.overlaySelector).find(b).get(0);
            b = this._getOffset(a, !0);
            b = Math.abs(b - c) / (10 * this.setting.rowHeight);
            d = d > b ? b : d;
            d = $.AnyPicker.extra.bHasPointer && this.tmp.bIsTouched && "auto" === h ? 0 : .1 > d ? .1 : d;
            $.AnyPicker.extra.bHasCSS3D ? (a.style[$.AnyPicker.extra.sCSSTransition] = $.AnyPicker.extra.sCSSTransformStyle + " " + d + "s ease-out",
            a.style[$.AnyPicker.extra.sCSSTransform] = "translate3d(0px, " + -c + "px, 0px)") : $(a).animate({
                top: -c
            }, 100);
            this.tmp.iOffset = c;
            c = this._getScrollingData();
            this._performTransitionAfter(c, l, k, h, d, m);
            this._clearScrollTicker()
        },
        _performTransitionAfter: function(a, b, c, d, e, f) {
            var g = this;
            setTimeout(function() {
                !f || "drag" !== d && "mouseWheel" !== d || (g.tmp.oScrollTicker = 1,
                g._scrollToRow(a.iDir, b, c, a.iMinTopPos, a.iMaxTopPos, d));
                var k = $(a.oScrollingComp).get(0)
                  , l = "auto" === d ? a.iOffset : -g._getOffset(k, !1)
                  , h = l < a.iMinTopPos
                  , m = l > a.iMaxTopPos
                  , p = Math.abs(l);
                h ? l = a.iMinTopPos : m && (l = a.iMaxTopPos);
                h || m ? (e = Math.abs(p - l) / (10 * g.setting.rowHeight),
                $.AnyPicker.extra.bHasCSS3D ? (k.style[$.AnyPicker.extra.sCSSTransition] = $.AnyPicker.extra.sCSSTransformStyle + " " + e + "s ease-out",
                k.style[$.AnyPicker.extra.sCSSTransform] = "translate3d(0px, " + -Math.abs(l) + "px, 0px)") : $(k).animate({
                    top: -Math.abs(l)
                }, 100),
                a.iOffset = l,
                g._skipDisabledRowAfter(a, l, d, e, f)) : (f || p === a.iMinTopPos || p === a.iMaxTopPos) && g._skipDisabledRow(d, a.iScrollingComp, p, a.iDir)
            }, 1E3 * e)
        },
        _skipDisabledRowAfter: function(a, b, c, d, e) {
            var f = this;
            setTimeout(function() {
                var d = "auto" === c ? b : a.iOffset;
                (e || d === a.iMinTopPos || d === a.iMaxTopPos) && f._skipDisabledRow(c, a.iScrollingComp, d, a.iDir)
            }, 1E3 * d)
        },
        _getOffset: function(a, b) {
            var c = $(a).hasClass("ap-component-data") ? $(a).css("transform") : $(a).find(".ap-component-data").css("transform")
              , d = 0;
            $.CF.isValid(c) && ("none" === c ? d = 0 : (c = c.replace("matrix(", ""),
            c = c.replace(")", ""),
            c = c.split(", "),
            d = 6 < c.length ? parseInt(c[13]) : parseInt(c[5])));
            return b ? Math.abs(d) : d
        },
        _scrollToRow: function(a, b, c, d, e, f) {
            null !== this.tmp.oScrollTicker && (f = $(this.tmp.oScrollingComp).get(0),
            c = this._getOffset(f, !1),
            b = c % this.setting.rowHeight,
            0 !== b || 0 === b && (c > d || c < -e)) && (c = Math.abs(c),
            c = -1 === a ? c + (this.setting.rowHeight - Math.abs(b)) : c + b,
            c = c > e ? e : c < d ? d : c,
            $.AnyPicker.extra.bHasCSS3D ? (f.style[$.AnyPicker.extra.sCSSTransition] = $.AnyPicker.extra.sCSSTransformStyle + " 0.4s ease-out",
            f.style[$.AnyPicker.extra.sCSSTransform] = "translate3d(0px, " + -Math.abs(c) + "px, 0px)") : $(f).animate({
                top: -Math.abs(c)
            }, 100),
            this.tmp.iOffset = c)
        },
        __scrollToSelectedRow: function() {
            var a, b = 0;
            for (a = 0; a < this.tmp.numOfComp; a++) {
                var c = $(this.tmp.overlaySelector).find("#ap-component-" + a + " .ap-row-selected")
                  , c = 0 < c.length ? c[0] : null;
                if (null !== c) {
                    var c = $(c).position().top
                      , d = this.tmp.iExt * this.setting.rowHeight
                      , c = 0 === c ? c : c - d;
                    this.callScrollToPosition(a, this, c, b);
                    b += 200
                }
            }
        },
        callScrollToPosition: function(a, b, c, d) {
            d = {};
            d.data = {
                component: a,
                apo: b
            };
            this._setScrollingData(d);
            this._scrollToPosition("auto", c, !0, "#ap-component-" + a + " .ap-component-data")
        },
        setSelectedAndInvalidValuesForRows: function(a) {
            $.CF.compareStrings(this.setting.mode, "select") && this.__disableInvalidRowsOfSelect();
            a && this.__scrollToSelectedRow()
        },
        __changeComponentValue: function(a, b) {
            var c = this.setting.dataSource[a].data, d, e;
            for (d = 0; d < c.length; d++)
                e = "#ap-row-" + a + "-" + d,
                e = $(this.tmp.overlaySelector).find(e),
                c[d].val === b ? (c[d].selected = !0,
                e.attr("aria-selected", "true"),
                e.addClass("ap-row-selected")) : (c[d].selected = !1,
                e.attr("aria-selected", "false"),
                e.removeClass("ap-row-selected"))
        },
        _skipDisabledRow: function(a, b, c, d) {
            var e = this
              , f = "#ap-component-" + b + " .ap-component-data"
              , g = $(e.tmp.overlaySelector).find(f).get(0)
              , k = Math.floor(c / e.setting.rowHeight)
              , l = "#ap-row-" + b + "-"
              , h = l + k
              , m = $(g).find(".ap-row").length - 2 * e.tmp.iExt
              , p = $(g).find(h).hasClass("ap-row-disabled")
              , h = -1
              , n = 0
              , q = {};
            $.CF.isValid(g) && p ? (1 === d && (h = e._findRows(b, k, m, g, d),
            -1 === h && (d = -1,
            n = 1)),
            -1 === d && (h = e._findRows(b, k, m, g, d),
            -1 === h && 0 === n && (d = 1,
            h = e._findRows(b, k, m, g, d))),
            g = -1 !== h ? $(g).find(l + h).position().top - e.tmp.iExt * e.setting.rowHeight : -1,
            -1 !== h && c !== g ? (q.data = {
                component: b,
                apo: e
            },
            e._setScrollingData(q),
            e._scrollToPosition("auto", g, !0, f)) : setTimeout(function() {
                e._actionsOnComponentStop(a, b, k, c, d)
            }, 200)) : setTimeout(function() {
                e._actionsOnComponentStop(a, b, k, c, d)
            }, 200)
        },
        _actionsOnComponentStop: function(a, b, c, d, e) {
            this.__setAriaSelectedForRowElement(b, d, e);
            this._getSelectedValueInComponent(null);
            if ($.CF.compareStrings(this.setting.inputChangeEvent, "onChange"))
                this._setOutput();
            else if ("DynamicString" === this.tmp.sHeaderTitleType && $.CF.compareStrings(this.setting.mode, "select"))
                for (d = 0; d < this.tmp.numOfComp; d++)
                    0 !== d && (sHeaderTitle += " "),
                    sHeaderTitle += this.tmp.selectedValues.values[d].label;
            "auto" !== a && $.CF.isValid(this.setting.onChange) && this.setting.onChange.call(this, b, c, this.tmp.selectedValues, a);
            this.setSelectedAndInvalidValuesForRows(!1)
        },
        _findRows: function(a, b, c, d, e) {
            if (-1 === e)
                for (b += 1; b < c; b++) {
                    if (!$(d).find("#ap-row-" + a + "-" + b).hasClass("ap-row-disabled"))
                        return b
                }
            else if (1 === e)
                for (--b; 0 < b; b--)
                    if (!$(d).find("#ap-row-" + a + "-" + b).hasClass("ap-row-disabled"))
                        return b;
            return -1
        },
        __setAriaSelectedForRowElement: function(a, b, c) {
            var d = $(this.tmp.overlaySelector).find("#ap-component-" + a), e;
            0 === b && (b = this._getOffset(d, !0));
            1 === c ? e = Math.floor(b / this.setting.rowHeight) : -1 === c && (e = Math.ceil(b / this.setting.rowHeight));
            b = d.find(".ap-row");
            a = d.find("#ap-row-" + a + "-" + e);
            b.attr("aria-selected", "false");
            b.removeClass("ap-row-selected");
            a.attr("aria-selected", "true");
            a.addClass("ap-row-selected")
        },
        _getSelectedValueInComponent: function(a) {
            var b, c = [];
            this.tmp.selectedValues = {};
            if ($.CF.isValid(a))
                b = $(this.tmp.overlaySelector).find("#ap-component-" + a + " .ap-row-selected"),
                c.push({
                    component: a,
                    val: b.data("value"),
                    label: b.data("label")
                });
            else
                for (a = 0; a < this.tmp.numOfComp; a++)
                    b = $(this.tmp.overlaySelector).find("#ap-component-" + a + " .ap-row-selected"),
                    c.push({
                        component: a,
                        val: b.data("value"),
                        label: b.data("label")
                    });
            this.tmp.selectedValues.values = c
        },
        __getDataSourceValueFromLabel: function(a, b, c) {
            var d, e, f, g = "";
            if ($.CF.isValid(b))
                for (e = this.setting.dataSource[b].data,
                d = 0; d < e.length; d++)
                    f = e[d],
                    $.CF.compareStrings(f.label, a) ? (g = f.val,
                    c && (f.selected = !0)) : c && (f.selected = !1),
                    this.setting.dataSource[b].data[d] = f;
            else
                for (b = 0; b < this.tmp.numOfComp; b++)
                    for (e = this.setting.dataSource[b].data,
                    d = 0; d < e.length; d++)
                        f = e[d],
                        $.CF.compareStrings(f.label, a) ? (c && (f.selected = !0),
                        g = f.val) : c && (f.selected = !1);
            return g
        },
        __getValuesOfComponent: function(a, b) {
            var c = null, d;
            if ("component" === a)
                if (this.setting.components[b].component === b)
                    c = this.setting.components[b];
                else
                    for (d = 0; d < this.tmp.numOfComp; d++)
                        this.setting.components[d].component === b && (c = this.setting.components[d]);
            else if ("datasource" === a)
                if (this.setting.dataSource[b].component === b)
                    c = this.setting.dataSource[b];
                else
                    for (d = 0; d < this.tmp.numOfComp; d++)
                        this.setting.dataSource[d].component === b && (c = this.setting.dataSource[d]);
            return c
        }
    });
    n.prototype = $.extend(n.prototype, {
        __setComponentsOfSelect: function() {
            var a = this;
            if (null === a.setting.dataSource)
                if (a.tmp.oElemValid.bIsListItem || a.tmp.oElemValid.bIsSelect) {
                    var b, c;
                    a.setting.components = [];
                    var d = {
                        component: 1
                    };
                    d.name = $(a.elem).data("name");
                    d.label = $(a.elem).data("label");
                    a.setting.components.push(d);
                    var e = [];
                    a.tmp.oElemValid.bIsListItem ? b = "li" : a.tmp.oElemValid.bIsSelect && (b = "option");
                    $(a.elem).find(b).each(function() {
                        c = $(this);
                        var b = {
                            val: c.attr("value") || c.data("value") || c.text(),
                            label: c.text(),
                            selected: function() {
                                return c.attr("selected") || void 0 !== c.attr("data-selected") && "true" === c.attr("data-selected") ? !0 : !1
                            },
                            disabled: function() {
                                return c.attr("disabled") || void 0 !== c.data("disabled") && "true" === c.data("disabled") ? !0 : !1
                            }
                        };
                        b.disabled ? b.selected = !1 : b.selected && (a.tmp.selected = {
                            val: b.val,
                            displayVal: b.displayVal
                        });
                        e.push(b)
                    });
                    a.setting.dataSource = [];
                    b = {
                        component: 1
                    };
                    b.data = e;
                    a.setting.dataSource.push(b);
                    a.tmp.numOfComp = 1;
                    $.CF.compareStrings(a.setting.headerTitle.contentBehaviour, "Dynamic") && $.CF.isValid(a.setting.headerTitle.format) && ("function" === typeof a.setting.headerTitle.format ? a.tmp.sHeaderTitleType = "DynamicFunction" : "string" === typeof a.setting.headerTitle.format && (a.tmp.sHeaderTitleType = "DynamicString"))
                } else
                    console.log("You will have to specify dataSource either as a JSON object or as <ul>, <ol>, <dl> or <select>")
        },
        __disableInvalidRowsOfSelect: function() {
            var a, b, c = this.setting.dataSource[0].data;
            for (a = 0; a < c.length; a++)
                (b = $.CF.isValid(c[a].disabled)) && !0 === c[a].disabled && $(this.elem).find("#ap-row-0-" + a).addClass("ap-row-disabled")
        }
    })
}
)();
