var albumList = {
    options:{
        pageNum:"",
        isMoreIndex:0
    },

    init:function(){
        var _this = this;
        base.init(function(){
            _this.getAlbum();
            if(base.options.isBind){
                base.getOnPlayList(2,1);
            }
            $('.onplay-text').css('font-size',multilingual.tranLang("12px"));
        });

        base.scrollPage(function(){
            if(_this.options.isMoreIndex!=1 && _this.options.isMoreIndex!=3){//1为查看更多;3为获取失败，重新获取
                return false;
            }
            _this.getAlbum();
        });
    },

    getAlbum:function(){
        var _this = this;
        _this.options.pageNum = $('.album-list').attr('data-page');
        _this.options.pageNum = _this.options.pageNum?_this.options.pageNum:1;
        if(_this.options.isMoreIndex==4 || _this.options.isMoreIndex==6){
          return false;
        }
        $('.album-content .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
        multilingual.refreshLang();
        base.getAlbumList(_this.options.pageNum,10,function(error,message,data){
            _this.showAlbumHtml(error,message,data);
        });
    },

    showAlbumHtml:function(error,message,data){
        var _this = this;
        if(error==0){
            _this.options.isMoreIndex = data.more;
            if(data.length!=0){
                var picUrl = data.picurlhead,
                    data = data.list,
                    content = "",
                    aurl = "";
                for(i=0;i<data.length;i++){
                    aurl = "songlist.html?type=2&id="+data[i]['tid']+"&name="+data[i]['s'];
                    content +='<a class="album-item" href="'+aurl+'" title="">\
                       <img src="'+picUrl+data[i]['fid']+'" alt="">\
                       <span class="dis-block text-ellipsis">'+data[i]['s']+'</span>\
                    </a>';
                }
                $('.album-list').append(content).attr("data-page",parseInt(_this.options.pageNum)+1);
                var imgW = $('.album-list').find('img').width();
                $('.album-list').find('img').height(imgW+"px");
                base.freshScoll();
            }else{
                if(_this.options.pageNum==1){
                    _this.options.isMoreIndex = 4;
                }else{
                    _this.options.isMoreIndex = 6;//显示有下一页,请求无数据
                } 
            }
        }else{
            _this.options.isMoreIndex = 3;
        }

        if(_this.options.isMoreIndex==0){//加载到底不显示提示语
            _this.options.isMoreIndex = 6;
        }
        $('.album-content .more-tip').html(base.options.isMore[_this.options.isMoreIndex]).attr('data-ismore',_this.options.isMoreIndex).attr('data-method',"getSongData");
        base.freshScoll();
    }
}
albumList.init();
