precision highp float;
varying highp vec2 vCamTextureCoord;
uniform sampler2D uCamTexture;
uniform vec4 srcRect;
uniform vec4 dstRect;


void main(){
	lowp vec4 c1 = texture2D(uCamTexture, vCamTextureCoord);

	lowp vec2 vCamTextureCoord2 = vec2(vCamTextureCoord.x,1.0 - vCamTextureCoord.y);
	vec2 point = vCamTextureCoord2;

	if(point.x>dstRect.r && point.x<dstRect.b && point.y>dstRect.g && point.y<dstRect.a)
    {
		vec2 imagexy = vec2(
			(srcRect.b - srcRect.r) * (point.x - dstRect.r) / (dstRect.b - dstRect.r) + srcRect.r,
			1.0 - ((srcRect.a - srcRect.g) * (point.y - dstRect.g) / (dstRect.a - dstRect.g) + srcRect.g)
		);
        c1 = texture2D(uCamTexture, imagexy);
    }

	gl_FragColor = c1;
}