var dProtocolOpt = {

	option : {
		bindstatus : false,
		companycode : "",
		supportfullsongdb : "1", //1不支持 0支持
		supportfreecloudsong : "1", //1不支持 0支持
	},

	/**
	 *解绑通知
	 */
	notifyUnbind : function(){
		var _this = this,
		    _option = this.option;

		_option.bindstatus = false;
	},

	/**
	 *获取首页专辑列表
	 */
	getD330 : function(pagenum,pagelength,callback){
		var _this = this;
		
		_this._initBefore(function(){
			var cmdid = "D330";
		
			var datajson = _this._buildProtocol(cmdid,pagenum,pagelength);
			var getlength = (typeof datajson.body.requestnum === "undefined")?0:datajson.body.requestnum;
			_this._parseProtocol(datajson,function(error,message,data){
				if(error != 0){ data = {rs:{}}; }
				var length = (typeof data.rs.return === "undefined")?0:data.rs.return;
				var list = (typeof data.rs.r === "undefined")?{}:data.rs.r;
				var more = (Number(getlength) > Number(length))?'0':'1'; //是否还有更多 1有 0没有
				var picurlhead = (typeof data.picurlhead === "undefined")?"":data.picurlhead+"?fileid=";
				var rs_data = {
						length:length.toString(),
						more:more.toString(),
						picurlhead:picurlhead,
						list:list
					};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		});
	},

	/**
	 *获取专辑列表歌曲
	 */
	getD332 : function(albumid,pagenum,pagelength,callback){
		var _this = this;
		
		_this._initBefore(function(){
			var cmdid = "D332";
		
			var datajson = _this._buildProtocol(cmdid,pagenum,pagelength,{tid:albumid.toString()});
			var getlength = (typeof datajson.body.requestnum === "undefined")?0:datajson.body.requestnum;
			_this._parseProtocol(datajson,function(error,message,data){
				if(error != 0){ data = {rs:{}}; }
				var length = (typeof data.rs.return === "undefined")?0:data.rs.return;
				var list = (typeof data.rs.r === "undefined")?{}:data.rs.r;
				var more = (Number(getlength) > Number(length))?'0':'1'; //是否还有更多 1有 0没有
				var picurlhead = (typeof data.picurlhead === "undefined")?"":data.picurlhead+"?fileid=";
				var picid = (typeof data.picid === "undefined")?"0":data.picid;
				var albumpicurl = picurlhead+picid;
				var rs_data = {
						length:length.toString(),
						more:more.toString(),
						albumpicurl:albumpicurl,
						list:list
					};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		});
	},
	
	/**
	 *搜索关键字提示
	 */
	getD316 : function(keyword,type,pagenum,pagelength,callback){
		var _this = this;

		type = (type!=0||type!=1)?2:type; //搜索类型0表示歌曲1表示歌星2表示全部

		_this._initBefore(function(){
			var cmdid = "D316";
		
			var datajson = _this._buildProtocol(cmdid,pagenum,pagelength,{keywords:keyword.toString(),type:type.toString()});
			var getlength = (typeof datajson.body.requestnum === "undefined")?0:datajson.body.requestnum;
			_this._parseProtocol(datajson,function(error,message,data){
				if(error != 0){ data = {records:{}}; }
				var length = (typeof data.records.returnnum === "undefined")?0:data.records.returnnum;
				var list = (typeof data.records.record === "undefined")?{}:data.records.record;
				var more = (Number(getlength) > Number(length))?'0':'1'; //是否还有更多 1有 0没有
				var picurlhead = (typeof data.records.picurlhead === "undefined")?"":data.records.picurlhead+"?fileid=";
				var rs_data = {
						length:length.toString(),
						more:more.toString(),
						picurlhead:picurlhead,
						list:list
					};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		});
	},

	/**
	 *通过歌星名称查找歌星信息(模糊匹配歌星名称)
	 */
	getSingerInfoWithSingerNameByD302 : function(singername,pagenum,pagelength,callback){
		var _this = this;

		_this._sendD302({songstername:singername.toString()},pagenum,pagelength,function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	/**
	 *通过歌星ID查找歌星信息
	 */
	 getSingerInfoWithIdByD302 : function(singerid,callback){
	 	var _this = this;

		_this._sendD302({songsterid:singerid.toString()},1,1,function(error,message,data){
			if(error == 0){
				var singerInfo = data.list[0];
				var picurlhead = data.picurlhead;

				data = {
					picurlhead : picurlhead,
					info : singerInfo
				};
			}else{
				data = {};
			}

        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	 },

	_sendD302 : function(infojson,pagenum,pagelength,callback){
		var _this = this;
		
		_this._initBefore(function(){
			var cmdid = "D302";
			
			var datajson = _this._buildProtocol(cmdid,pagenum,pagelength,infojson);
			var getlength = (typeof datajson.body.requestnum === "undefined")?0:datajson.body.requestnum;
			_this._parseProtocol(datajson,function(error,message,data){
				if(error != 0){ data = {rs:{}}; }
				var length = (typeof data.rs.return === "undefined")?0:data.rs.return;
				var list = (typeof data.rs.r === "undefined")?{}:data.rs.r;
				var more = (Number(getlength) > Number(length))?'0':'1'; //是否还有更多 1有 0没有
				var picurlhead = (typeof data.picurlhead === "undefined")?"":data.picurlhead+"?fileid=";
				var rs_data = {
						length:length.toString(),
						more:more.toString(),
						picurlhead:picurlhead,
						list:list
					};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		});
	},

	/**
	 *通过歌星字母索引获取歌星列表
	 */
	getSingerListWithIndexByD324 : function(letterindex,pagenum,pagelength,callback){
		var _this = this;
		
		_this._sendD324({letterindex:letterindex.toString()},pagenum,pagelength,function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	_sendD324 : function(infojson,pagenum,pagelength,callback){
		var _this = this;
		
		_this._initBefore(function(){
			var cmdid = "D324";
			
			var datajson = _this._buildProtocol(cmdid,pagenum,pagelength,infojson);
			var getlength = (typeof datajson.body.requestnum === "undefined")?0:datajson.body.requestnum;
			_this._parseProtocol(datajson,function(error,message,data){
				if(error != 0){ data = {rs:{}}; }
				var length = (typeof data.rs.return === "undefined")?0:data.rs.return;
				var list = (typeof data.rs.r === "undefined")?{}:data.rs.r;
				var more = (Number(getlength) > Number(length))?'0':'1'; //是否还有更多 1有 0没有
				var picurlhead = (typeof data.picurlhead === "undefined")?"":data.picurlhead+"?fileid=";
				var rs_data = {
						length:length.toString(),
						more:more.toString(),
						picurlhead:picurlhead,
						list:list
					};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		});
	},

	/**
	 *通过歌曲名查找歌曲(模糊匹配歌曲名)
	 */
	getSongListWithSongNameByD544 : function(songname,pagenum,pagelength,callback){
		var _this = this;

		_this._sendD544({searchkey:songname.toString()},pagenum,pagelength,function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	/**
	 *通过歌星ID查找歌曲
	 */
	getSongListWithSingerIdByD544 : function(singerid,pagenum,pagelength,callback){
		var _this = this;

		_this._sendD544({songsterid:singerid.toString()},pagenum,pagelength,function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	_sendD544 : function(infojson,pagenum,pagelength,callback){
		var _this = this;
		
		_this._initBefore(function(){
			var cmdid = "D544";
			
			var datajson = _this._buildProtocol(cmdid,pagenum,pagelength,infojson);
			var getlength = (typeof datajson.body.requestnum === "undefined")?0:datajson.body.requestnum;
			_this._parseProtocol(datajson,function(error,message,data){
				if(error != 0){ data = {rs:{}}; }
				var length = (typeof data.rs.return === "undefined")?0:data.rs.return;
				var list = (typeof data.rs.r === "undefined")?{}:data.rs.r;
				var more = (Number(getlength) > Number(length))?'0':'1'; //是否还有更多 1有 0没有
				var rs_data = {
						length:length.toString(),
						more:more.toString(),
						list:list
					};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		});
	},

	/**
	 *搜索歌曲和歌星
	 */
	getSingerAndSongWithKeyWord : function(keyword,pagenum,pagelength,callback){
		var _this = this;

		var singerInfo = {};
		var songInfo = {};
		if(pagenum==1){
			_this.getSingerInfoWithSingerNameByD302(keyword,1,4,function(singer_error,singer_message,singer_data){
				var singerlistlimit = 3; //最多只显示3个歌手
				if(singer_error==0){
					var singerlistlength = (typeof singer_data.length === "undefined")?0:singer_data.length;
					var more = (Number(singerlistlength) > Number(singerlistlimit))?1:0;  //是否还有更多 1有 0没有
					singer_data.more = more;
					singerInfo = singer_data;
				}

				_this.getSongListWithSongNameByD544(keyword,1,pagelength,function(error,message,song_data){
					if(error==0){
						songInfo = song_data;
					}

					var rs_data = {
						singerlist : singerInfo,
						songlist : songInfo
					};
		        	if(typeof callback === "function"){ callback(error,message,rs_data); }
				});
			});
		}else{
			_this.getSongListWithSongNameByD544(keyword,pagenum,pagelength,function(error,message,song_data){
				if(error==0){
					songInfo = song_data;
				}

				var rs_data = {
					singerlist : singerInfo,
					songlist : songInfo
				};
	        	if(typeof callback === "function"){ callback(error,message,rs_data); }
			});
		}
	},

	_initBefore : function(callback){
		var _this = this;

		_this._getBindInfo(callback);
	},

	_getBindInfo : function(callback){
		var _this = this;
		var _option = this.option;

		if(_option.bindstatus){
			callback();
			return false;
		}

		KmApi.getRoomInfo(function(result){
			// alert(JSON.stringify(result));
			if(result.result == 0){ //有绑定
				_option.bindstatus = true;
				_option.companycode = result.companycode;
				_option.supportfullsongdb = result.stbinfo.supportfullsongdb;
				_this._getCompanyVipState(callback);
				return false;
			}
			callback();
		});
	},

	_getCompanyVipState : function(callback){
		var _this = this;
		var _option = this.option;

		KmApi.getCompanyVipState(function(result){
			// alert(JSON.stringify(result));
			var vipstate = (typeof result.cloudsong.vip === "undefined")?0:result.cloudsong.vip;
			_option.supportfreecloudsong = (vipstate==1)?1:0;
			callback();
		});
	},

	/**
	  *协议组包
	  */
	_buildProtocol : function(cmdid,pagenum,pagelength,infojson){
		var _this = this;
		var _option = this.option;

		cmdid = cmdid || '';
		pagenum = pagenum || 1;
		pagelength = pagelength || 20;
		infojson = infojson || {};

		var startpos = (pagenum-1)*pagelength;
		startpos++;
		var requestnum = pagelength;

		var companycode = _option.companycode;
		var supportfullsongdb = (_option.supportfullsongdb==0&&_option.supportfreecloudsong==0)?"0":"1";

		var headerjson = {};
		var bodyjson = {
	    	"cmdid" : cmdid,
	    	"companycode" : companycode,
	    	"supportfullsongdb" : supportfullsongdb,
	    	"startpos" : startpos.toString(),
	    	"requestnum" : requestnum.toString()
		};

		bodyjson = _this._extend(bodyjson,infojson);

		return {header:headerjson,body:bodyjson};
	},

	/**
	 *协议解析
	 */
	_parseProtocol : function(datajson,callback){
		var _this = this;
		var headerjson = datajson.header || {};
		var bodyjson = datajson.body || {};
		KmApi.dProtocol({header:headerjson,body:bodyjson},function(rs){
        	var error = (typeof rs.data.result === "undefined")?-99:rs.data.result;
        	var message = (typeof rs.data.resultmsg === "undefined")?'协议发送失败[app]':rs.data.resultmsg;
        	var dataobj = (typeof rs.data.body === "undefined")?{}:rs.data.body;

        	var data = {};
        	if(error == 0){
        		error = (typeof dataobj.errorcode === "undefined")?-98:dataobj.errorcode;
        		message = (typeof dataobj.errormessage === "undefined")?'解析失败[vod]':dataobj.errormessage;
        		data = (typeof dataobj === "undefined")?{}:dataobj;
        	}

        	if(typeof callback === "function"){ callback(error,message,data); }
        });
	},

	_extend : function(){
        var result = {}, obj, k;
        for(var i = 0, len = arguments.length; i < len; i++){
            obj = arguments[i];
            if(typeof obj === 'object'){
                for(k in obj){
                    typeof obj[k]=='boolean'?result[k] = obj[k]:obj[k] && (result[k] = obj[k]);
                }
            }
        }
        return result;
    },


}
