var ctrPage = {
    options:{
        btnType:"",
        btnTip:"",
        specialType:['201','202','203','204'],//背景音乐、麦克风的加减类型
        playCtrTips:['成功','已开始重唱该首歌曲','已切换到下一首歌曲','已呼叫服务员，请稍等','已调大麦克风音效','已调小麦克风音效','已调大背景音乐','已调小背景音乐']
    },

    init:function(){
        var _this = this;
        base.init(function(){
            if(base.options.isBind){
                base.getOnPlayList(2,1);
            }
            $('.ctl-top span').css('font-size',multilingual.tranLang("15px"));
        });
        _this.clicks();
    },

    clicks:function(){
        var _this = this;
        $('.ctl-page .play-btn').click(function(event) {
            _this.options.btnType = $(this).attr('data-type');
            _this.options.btnTip = $(this).attr('data-tip');
            if(!base.options.isBind){
                base.showBindTip(0);
                return false;
            }

            if(!_this.options.btnType) {
                kmDialog.toast("操作类型错误");
                return false;
            }
            //切歌与呼叫服务
            if(_this.options.btnType == 102 || _this.options.btnType == 2){
                var dialogContent = "是否切换到下一首歌曲";

                if(_this.options.btnType == 2){
                    dialogContent = "是否需要呼叫服务";
                }
                kmDialog.confirm(dialogContent,function(){
                    if(_this.options.btnType==102){
                        _this.doCtr();
                    }else{
                        _this.callService();
                    }
                });
                return false;
            }else if(_this.options.specialType.indexOf(_this.options.btnType)!=-1){
                kmDialog.toast(_this.options.playCtrTips[_this.options.btnTip]);
                _this.doCtr();
            }else{
                _this.doCtr();
            }
        });
    },

    //呼叫服务
    callService:function(){
        var _this = this;
        eProtocolOpt.sendE000("",function(error,message,data){
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
            if(error==0){
                kmDialog.toast(_this.options.playCtrTips[_this.options.btnTip]);
            }else if(error==199 || error==1199){//error==199 || error==1199
                base.unBindRoom(function(){
                    base.showBindTip(1);
                });
            }else{
                kmDialog.toast(message);
            }
        });
    },

    //操作播控
    doCtr:function(){
        var _this = this;
        eProtocolOpt.playControllByE400(_this.options.btnType,function(error,message,data){
            if(_this.options.specialType.indexOf(_this.options.btnType)==-1){
                // var result = JSON.stringify(data);
                // alert("error:"+error+" message:"+message+" data:"+result);
                if(error==0){//error==0
                    kmDialog.toast(_this.options.playCtrTips[_this.options.btnTip]);
                    //切歌成功
                    if(_this.options.btnType == 102){
                      base.getOnPlayList(2,1);//切歌成功，只请求接口，不填充列表
                    }
                }else if(error==199 || error==1199){//error==199 || error==1199
                    base.unBindRoom(function(){
                        base.showBindTip(1);
                    });
                }else{
                    kmDialog.toast(message);
                }
            }
        });
    }
}

ctrPage.init();
