var onPlay = {

    options:{
       isMoreIndex:0,
       pageNum:""
    },

    init:function(){
        var _this = this;
        base.init(function(){
            _this.getOnPlayData();
        });
        base.scrollPage(function(){
            if(_this.options.isMoreIndex!=1 && _this.options.isMoreIndex!=3){//1为查看更多;3为获取失败，重新获取
              return false;
            }
            _this.getOnPlayData();
        });
        _this.clicks();
    },

    clicks:function(){
        var _this = this;
        $('.on-play').on('click','.list-btn',function(){
            if($(this).attr('data-sequence')!=1){
                if($(this).attr('data-sequence')==0){//切歌
                    kmDialog.confirm("是否切换到下一首歌曲",function(){
                        _this.nexSong();
                    });
                }else{//顶歌
                    var obj = $(this),
                        songKp = obj.attr("data-songkp"),
                        upStatus = obj.attr("data-upstatus");
                    if((songKp==13 || songKp==14) && upStatus==0){
                        kmDialog.toast("下载中");
                        return false;
                    }               
                    base.upSong(obj,function(){
                        $('.on-play').html("").attr('data-page',1);
                        base.getOnPlayList(1,1,function(error,message,data){
                            _this.showOnPlayHtml(error,message,data);
                        });
                    });
                }
            }
        })
    },

    getOnPlayData:function(){
        var _this = this;
        _this.options.pageNum = $('.on-play').attr('data-page');
        _this.options.pageNum = _this.options.pageNum?_this.options.pageNum:1;
        $('.onplay-content .more-tip').html(base.options.isMore[2]).attr('data-ismore',3);
        multilingual.refreshLang();
        base.getOnPlayList(1,_this.options.pageNum,function(error,message,data){
            _this.showOnPlayHtml(error,message,data);
        });
    },

    //切歌
    nexSong:function(){
        var _this = this;
        kmDialog.loading();
        eProtocolOpt.playControllByE400(102,function(error,message,data){
            kmDialog.hideLoading();
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
            if(error==0){
                kmDialog.toast("成功");
                base.getOnPlayList(1,1,function(error,message,data){
                    _this.showOnPlayHtml(error,message,data);
                });
            }else if(error==199 || error==1199){
                base.unBindRoom(function(){
                    base.showBindTip(1);
                });
            }else{
                kmDialog.toast(message);
            }
        });
    },

    //填充已点列表
    showOnPlayHtml:function(error,message,data){
        var _this = this;
        if(error==0){
            _this.options.isMoreIndex = data.records.more;
            if(data.records.totalnum!=0){
               
                if(_this.options.pageNum==1){
                    $('.on-play').html("");
                    $('.on-num').html(data.records.totalnum);
                }
                var listData = data.records.record,
                    content = '',
                    sequence = '',
                    schText = "",
                    upBtnStatus = 1,//0 下载与等待 1 顶歌 2 重点
                    songNameIcon = "";
                for(i=0;i<listData.length;i++){
                    upBtnStatus = 1;
                    if((listData[i]['kp']==13 || listData[i]['kp']==14) && listData[i]['sch']!=100){//云歌曲
                        upBtnStatus = 0
                    }
                    sequence = parseInt(_this.options.pageNum-1)*15+parseInt(i);
                    content += '<li><div class="show-info">';
                    if(sequence==0){
                        content += '<div class="sequence-box music active">\
                                <i></i><i></i><i></i><i></i>';
                    }else{
                        content += '<div class="sequence-box">'+sequence+'';
                    }
                    content += '</div>';
                    content +='<div class="list-info flex-1">';
                    songNameIcon = '<h4><span class="song-name text-ellipsis">'+listData[i]['songname']+'</span></h4>';
                    if(listData[i]['kp']==13 || listData[i]['kp']==14){
                        songNameIcon = '<h4><span class="song-name cloud-song text-ellipsis">'+listData[i]['songname']+'</span></h4>';
                    }       
                    content += songNameIcon;
                    content +='<p>';
                    if(listData[i]['sr']==0){//来自点歌台listData[i]['sr']==0
                        content +='<i class="user-avatar"><img src="../images/another-avatar.png" alt=""></i>\
                                    <span langext="more">来自点歌台</span>';
                    }else{
                        content +='<i class="user-avatar"><img src="../images/default-avatar.png" alt=""></i>\
                                    <span langext="more">来自手机用户</span>';
                    }
                    content +='</p>';
                    content +='</div>';
                    if(sequence!=1){
                        content += '<div class="list-btn up-btn" data-sequence="'+sequence+'" data-songid="'+listData[i]['songid']+'" data-songkp="'+listData[i]['kp']+'" data-upstatus="'+upBtnStatus+'" ></div>';
                    }
                    content += '</div>';
                }
                $('.on-play').append(content).attr('data-page',parseInt(_this.options.pageNum)+1);
                multilingual.refreshLang();
            }else{
              if(_this.options.pageNum==1){
                _this.options.isMoreIndex = 4;
              }else{
                _this.options.isMoreIndex = 6;//显示有下一页,请求无数据
              } 
            }
          }else{
            _this.options.isMoreIndex = 3;
          }
        if(_this.options.isMoreIndex==0){//加载到底不显示提示语
            _this.options.isMoreIndex = 6;
        }
        $('.onplay-content .more-tip').html(base.options.isMore[_this.options.isMoreIndex]).attr('data-ismore',_this.options.isMoreIndex).attr('data-method',"getOnPlayData");
        base.freshScoll();
        multilingual.refreshLang();
    }
}
onPlay.init();