var searchPage = {
    options:{
        isMoreIndex:0,
        highlightWrap:"",
        searchKey:"",
        scrollKey:0,//定义页面滚动，加载的方法=》0加载歌曲 1加载歌手
        highlightColor:"#ff6b00"
    },

    init:function(){
        var _this = this;
        _this.operateSearch();
        base.songBtn();
        base.init(function(){
            $(".search-key").attr("placeholder",multilingual.tranLang("歌星、歌曲、简拼"));
        });
        
        base.scrollPage(function(){
            if(_this.options.searchKey==""){
                return false;
            }
            if(_this.options.scrollKey==0){
                _this.getSongByKey();
            }else{
                _this.getSingerByKey();
            }
        });

        base.options.myScroll.on("scrollStart",function(event){
            $('input.search-key').blur();
        });
    },

    //搜索相关
    operateSearch:function(){
        var _this = this;
       
        //清除输入
        $('.search-box').on("click",".clear-search",function(event) {
            $('input.search-key').blur();
            _this.options.searchKey = $.trim($('input.search-key').val());
            if(_this.options.searchKey == ""){//输入框为空，清除时不做任何操作
                return false;
            }
            $('.search-box input.search-key').val('');
            _this.options.searchKey = "";
            _this.resetSearch(2);
            base.options.myScroll.scrollTo(0, 0);    
        });

        //点击搜索按钮
        $('.page-top').on("click",".search-btn",function(event) {
            _this.options.searchKey = $.trim($('input.search-key').val());
            $('.search-page .search-song-list .song-list').attr("data-page",1);
            $('.search-result .search-singer-list .singer-list').attr("data-page",1);
            if(_this.options.searchKey!=""){
                _this.resetSearch(1);
                _this.getSingerAndSongBySearchKey();
            }else{
                kmDialog.toast("请输入搜索关键字");
            }
        });


        //监听输入框变化
        $('input.search-key').bind('input propertychange', function() {
            _this.options.searchKey = $.trim($(this).val());
            if(_this.options.searchKey != ''){
                $('.search-page .search-singer-list .singer-list').html("");
                $('.search-page .search-song-list .song-list').html("").attr("data-page",1);
                _this.getListByKeyWord();
            }else{
                base.options.myScroll.scrollTo(0, 0);    
                _this.resetSearch(2);//输入变为空，历史有记录即显示
            }
        });

        //点击搜索结果中的歌曲与历史记录
        $('.song-list').on('click','.name-item',function(){
            _this.options.searchKey = $(this).attr('data-key');
            $('input.search-key').val(_this.options.searchKey);
            $('.search-page .search-song-list .song-list').attr("data-page",1);
            _this.resetSearch(1);
            _this.getSingerAndSongBySearchKey();
        })

        //查看更多歌手
        $('.search-singer-list .more-tip').click(function(){
            $('.search-result .search-singer-list .singer-list').html("").attr("data-page",1);
            _this.resetSearch(1,2);
            _this.getSingerByKey();
        })
    },

    //关联词搜索歌曲
    getListByKeyWord:function(){
        var _this = this;
        $('.search-page .search-song-list .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
        multilingual.refreshLang();
        dProtocolOpt.getD316(_this.options.searchKey,2,1,20,function(error,message,data){
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
            if($.trim($('input.search-key').val())!=""){
                if(error==0){
                    if(data.list.length!=0){
                        var picUrl = data.picUrl,
                            listData = data.list,
                            singerContent = '',
                            songContent = '',
                            singerHead = "";
                        _this.options.isMoreIndex = 6;//默认不显示底部提示
                        for(i=0;i<listData.length;i++){
                            if(listData[i]['datatype'] == 1){
                                singerHead = picUrl+listData[i]['fid'];
                                var aurl = "songlist.html?type=1&id="+listData[i]['id']+"&name="+listData[i]['name'];
                                singerContent +='<a class="singer-item dis-flex" href="songlist.html" title="">\
                                                  <img src="'+picUrl+listData[i]['lfid']+'" alt="">\
                                                  <div class="singer-name highlight-key">'+listData[i]['name']+'</div>\
                                                </a>';
                            }else{
                                songContent +='<li class="name-item" data-key="'+listData[i]['name']+'">\
                                                <div class="key-info">\
                                                    <div class="list-info flex-1">\
                                                        <h4>\
                                                          <span class="song-name highlight-key text-ellipsis">'+listData[i]['name']+'</span>\
                                                        </h4>\
                                                    </div>\
                                                </div>\
                                            </li>';
                            }
                        }
                        _this.resetSearch(1);
                        $('.search-page .search-song-list .more-tip').addClass('none');
                        $('.search-singer-list .singer-list').html(singerContent);
                        $('.search-song-list .song-list').html(songContent);
                        _this.options.highlightWrap = $('.search-result').find('.highlight-key');
                        _this.highlightKey();
                    }else{//搜索为空
                        _this.resetSearch(1,1);
                    }
                }else{
                    _this.options.isMoreIndex = 3;
                }
                $('.search-page .search-song-list .more-tip').html(base.options.isMore[_this.options.isMoreIndex]);
                multilingual.refreshLang();
                base.freshScoll();
            }
        });
    },

    //点击搜索
    getSingerAndSongBySearchKey:function(){
        var _this = this,
            pageNum = 1;
        _this.options.scrollKey = 0;
        base.options.myScroll.scrollTo(0, 0);    
        $('.search-page .search-song-list .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
        multilingual.refreshLang();
        dProtocolOpt.getSingerAndSongWithKeyWord(_this.options.searchKey,1,10,function(error,message,data){
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
            var isMoreIndex = data.songlist.more;
            if(error==0){
                if(data.singerlist.length!=0 || data.songlist.length!=0){//data.allempty==1

                    if(data.singerlist.length!=0){
                        _this.showSingerList(0,data.singerlist,1);
                    }

                    if(data.songlist.length!=0){
                        _this.showSongList(error,data.songlist,1);
                    }

                    if(data.singerlist.length!=0 && data.songlist.length==0){
                        isMoreIndex = 6;
                    }
                }else{
                    _this.resetSearch(1,1);//搜索为空
                }
            }else{
                isMoreIndex = 3;//未处理
            }
            $('.search-page .search-song-list .more-tip').html(base.options.isMore[isMoreIndex]).attr('data-method',"getSingerAndSongBySearchKey").attr('data-ismore',isMoreIndex);
            multilingual.refreshLang();
        });
    },

    //查看更多歌手
    getSingerByKey:function(){
        var _this = this,
            pageNum = $('.search-singer-list .singer-list').attr('data-page');
        pageNum = pageNum?pageNum:1;
        var isMore = $('.search-page .search-singer-list .more-tip').attr('data-ismore');
        if(isMore==4 || isMore==6){
          return false;  
        }
        $('.search-page .search-singer-list .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
        multilingual.refreshLang();
        dProtocolOpt.getSingerInfoWithSingerNameByD302(_this.options.searchKey,pageNum,20,function(error,message,data){
            if(error==0){
                _this.showSingerList(1,data,pageNum);
            }
            // var result = JSON.stringify(data);
            // alert("歌手更多error:"+error+" message:"+message+" data:"+result);
        });
    },

    //查看更多歌曲
    getSongByKey:function(){
        var _this = this,
            pageNum = $('.search-song-list .song-list').attr('data-page');
            pageNum = pageNum?pageNum:1;
        var isMore = $('.search-page .search-song-list .more-tip').attr('data-ismore');
        if(isMore==4 || isMore==6 || isMore==0){
          return false;  
        }
        $('.search-page .search-song-list .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
        multilingual.refreshLang();
        dProtocolOpt.getSongListWithSongNameByD544(_this.options.searchKey,pageNum,10,function(error,message,data){
            _this.showSongList(error,data,pageNum);
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
        });
    },

    //填充歌手列表
    showSingerList:function(type,data,pageNum){//type为0是点击搜索显示歌手 1为查看更多歌手
        var _this = this,
            picurlhead = data.picurlhead,
            more = data.more,
            singerData = data.list,
            aurl = "";
            content = "";
        if(data.length!=0){
            for(i=0;i<data.length;i++){
                aurl = "songlist.html?type=1&id="+singerData[i]['id']+"&name="+singerData[i]['name'];
                content +='<a class="singer-item dis-flex" href="'+aurl+'" title="">\
                                <img src="'+picurlhead+singerData[i]['mfid']+'" alt="">\
                                <div class="singer-name highlight-key">'+singerData[i]['name']+'</div>\
                            </a>';
                if(type==0){
                    if(more==1){
                        $('.search-singer-list .more-tip').removeClass('none').html('查看更多歌手').attr('data-ismore',"");
                    }
                    if(i==2){
                        break;
                    }
                }
            }
            $('.search-singer-list .singer-list').append(content);
            if(type==1){
                _this.options.scrollKey = 1;
                $('.search-singer-list .singer-list').attr('data-page',parseInt(pageNum)+1);
                if(more==0){
                    more = 6;
                }
                $('.search-page .search-singer-list .more-tip').html(base.options.isMore[more]).attr('data-ismore',more);
            }
            _this.options.highlightWrap = $('.search-result').find('.highlight-key');
            _this.highlightKey();
            base.freshScoll();
        }else{
            if(type==1){
                $('.search-page .search-singer-list .more-tip').html(base.options.isMore[6]).attr('data-ismore',6);
            }
        }
        multilingual.refreshLang();
    },

    //填充歌曲列表
    showSongList:function(error,data,pageNum){
        var _this = this,
            songData = data.list,
            content = "",
            isMoreIndex = 0,
            songNameIcon = "";
        if(error==0){
            isMoreIndex = data.more;
            if(songData.length!=0){
                for(i=0;i<songData.length;i++){
                    songNameIcon = '<h4><span class="song-name text-ellipsis">'+songData[i]['s']+'</span></h4>';
                    if(songData[i]['kp']==13 || songData[i]['kp']==14){//云点歌 songData[i]['kp']==13 || songData[i]['kp']==14
                        songNameIcon = '<h4><span class="song-name cloud-song text-ellipsis">'+songData[i]['s']+'</span></h4>';
                    }
                    content +='<li>\
                            <div class="show-info"  data-songkp="'+songData[i]['kp']+'">\
                                <div class="list-info highlight-key flex-1">\
                                    '+songNameIcon+'\
                                    <p>'+songData[i]['g']+'</p>\
                                </div>\
                                <div class="list-btn" data-songid="'+songData[i]['id']+'" data-songname="'+songData[i]['s']+'" data-singername="'+songData[i]['g']+'" data-songkp="'+songData[i]['kp']+'"></div>\
                            </div>';
                            if(!(songData[i]['kp']==13 || songData[i]['kp']==14)){
                                content +='<div class="top-song" data-songid="'+songData[i]['id']+'" data-songkp="'+songData[i]['kp']+'">\
                                            <i>置顶</i>\
                                        </div>';
                            }
                        content +='</li>';
                }
                $('.search-song-list .song-list').append(content).attr('data-page',parseInt(pageNum)+1);
            }else{
                if(pageNum==1){
                    isMoreIndex = 4;
                }else{
                    isMoreIndex = 6;//显示有下一页,请求无数据
                } 
            }
        }else{
            isMoreIndex = 3;
        }
        if(isMoreIndex==0){//加载到底不显示提示语
            isMoreIndex = 6;
        }   
        $('.search-page .search-song-list .more-tip').html(base.options.isMore[isMoreIndex]).attr('data-method',"getSongByKey").attr('data-ismore',isMoreIndex);
        //高亮
        _this.options.highlightWrap = $('.search-page').find('.highlight-key');
        _this.highlightKey();
        base.freshScoll();
        multilingual.refreshLang();
    },

    //清空搜索列表
    //type为1显示搜索结果;2显示历史记录
    //key为1显示搜索为空的提示,2为查看歌手
    resetSearch:function(type,key){
        var _this = this;

        if(type==1){//显示搜索结果分为搜索有数据与搜索为空【歌手为空或者歌曲为空】
            $('.search-page .search-result').removeClass('none');
            $('.search-page .search-singer-list .singer-list').html("").attr('data-page',1);
            $('.search-page .search-song-list .song-list').html("").attr('data-page',1);

            if(key==1){
                $('.search-page .search-result-none').removeClass('none');
                $('.search-page .search-singer-list .more-tip').addClass('none');
                $('.search-page .search-song-list .more-tip').addClass('none');
            }else if(key==2){
                $('.search-page .search-result-none').addClass('none');
                $('.search-page .search-song-list .more-tip').addClass('none');
                $('.search-page .search-singer-list .more-tip').removeClass('none');
            }else{
                $('.search-page .search-result-none').addClass('none');
                $('.search-page .search-singer-list .more-tip').addClass('none');
                $('.search-page .search-song-list .more-tip').removeClass('none');//搜索结果不进行分页查询
            }
        }else if(type==2){//清除搜索和清空历史
            if(true){//搜索历史为空显示默认提示语
                $('.search-page .search-result').removeClass('none');
                $('.search-page .search-song-list .more-tip').removeClass('none').html(base.options.isMore[5]).attr('data-ismore',0);
                $('.search-page .search-singer-list .more-tip').addClass('none');
                $('.search-page .search-singer-list .singer-list').html("").attr('data-page',1);
                $('.search-page .search-song-list .song-list').html("").attr('data-page',1);
                $('.search-page .search-result-none').addClass('none');
            }else{
                $('.search-page .search-history-list').removeClass('none');
                $('.search-page .search-result').addClass('none');
            }
        }
        multilingual.refreshLang();
    },

    //高亮关键词
    highlightKey:function(){
        var _this = this;

        _this.options.highlightWrap.highlight(_this.options.searchKey,{
            hColor:_this.options.highlightColor
        });
    },
}

searchPage.init();
