var singerList = {
  options:{
    singerType:"热门",
    isMoreIndex:0,
    singerTypeArray:[]
  },

  init:function(){
    var _this = this;
    base.init(function(){
      _this.getSingerListByType();
      if(base.options.isBind){
        base.getOnPlayList(2,1);
      }
      $('.onplay-text').css('font-size',multilingual.tranLang("12px"));
    });

    base.scrollPage(function(){
      if(_this.options.isMoreIndex!=1 && _this.options.isMoreIndex!=3){//1为查看更多;3为获取失败，重新获取
        return false;
      }
      _this.getSingerListByType();
    });

    _this.setSingerType();//设置下拉框数据
  },

  setSingerType:function(){

    var _this = this;
    for(i=0;i<26;i++){
      _this.options.singerTypeArray.push({
        val: String.fromCharCode(65+i),
        label: String.fromCharCode(65+i)
      });
    }
    setTimeout(function(){
      var hotText = $('.hot-btn').html();
      _this.options.singerTypeArray.unshift({
        val: hotText,
        label: hotText
      });
    },300)

    $(".hot-btn").AnyPicker({
      mode: "select",
      components: [{
        component: 1,
        name: "currency",
        label: "Currency"
      }],
      dataSource: [{
        component: 1,
        data:_this.options.singerTypeArray
      }],
      theme: "iOS",
      formatOutput: function(oSelectedValues){
        sArrOutput = [];
        sArrOutput.push(oSelectedValues.values[0].val);
        return sArrOutput;
      }
    });

    //下拉框点击确定，进行数据请求
    $('body').on('touchstart','.ap-overlay .ap-button',function(event) {
      var selectType = $('.ap-overlay .ap-bg .ap-cont .ap-content .ap-content-middle .ap-row-selected').attr('data-value');
      if(selectType == _this.options.singerType){
        return false;
      }
      $('.singer-content .singer-list').html("").attr('data-page',1);
      _this.options.singerType = selectType;
      _this.getSingerListByType();
    });
  },

  getSingerListByType:function(){
    var _this = this,
        pageNum = $('.singer-content .singer-list').attr('data-page');
    pageNum = pageNum?pageNum:1;
    $('.singer-content .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
   
    multilingual.refreshLang();
    dProtocolOpt.getSingerListWithIndexByD324(_this.options.singerType,pageNum,20,function(error,message,data){
      // var result = JSON.stringify(data);
      // alert("error:"+error+" message:"+message+" data:"+result);
      if(error==0){
        _this.options.isMoreIndex = data.more;
        if(data.list.length!=0){
          var listData = data.list,
              picUrl = data.picurlhead;
              content = "",
              aurl = "";
          for(i=0;i<listData.length;i++){
              aurl = "songlist.html?type=1&id="+listData[i]['id']+"&name="+listData[i]['name'];
              content +='<a class="singer-item dis-flex" href="'+aurl+'" title="">\
                          <img src="'+picUrl+listData[i]['mfid']+'" alt="">\
                          <div class="singer-name">'+listData[i]['name']+'</div>\
                        </a>';
          }
          $('.singer-content .singer-list').append(content).attr('data-page',parseInt(pageNum)+1);
          base.freshScoll(pageNum);
          if(pageNum==1){
            base.options.myScroll.scrollTo(0, 0);
          }
        }else{
          if(pageNum==1){
            _this.options.isMoreIndex = 4;
          }else{
            _this.options.isMoreIndex = 6;//显示有下一页,请求无数据
          } 
        }
      }else{
        _this.options.isMoreIndex = 3;
      }
      if(_this.options.isMoreIndex==0){//加载到底不显示提示语
        _this.options.isMoreIndex = 6;
      }
      $('.singer-content .more-tip').html(base.options.isMore[_this.options.isMoreIndex]).attr('data-ismore',_this.options.isMoreIndex).attr('data-method',"getSingerListByType");
      multilingual.refreshLang();
    });
  }
}

singerList.init();
