var songList = {

  options:{
    type:"",//type为1是歌手歌曲 2为专辑歌曲
    id:"",//'专辑id或是歌手id'
    titleName:"歌曲",
    isMoreIndex:0,
    pageNum:""
  },

  init:function(){
    var _this = this;
    _this.options.type = base.getUrlParam('type');
    _this.options.id = base.getUrlParam('id');
    _this.options.titleName = base.getUrlParam('name')?base.getUrlParam('name'):_this.options.titleName;
    $('.page-title').html(_this.options.titleName);
   
    base.songBtn();

    base.init(function(){
      if(base.options.isBind){
        base.getOnPlayList(2,1);
      }
      if(_this.options.type==1 && _this.options.id){
        _this.getSingerAvatar(function(){
          _this.getSongData(function(error,message,data){
            _this.showSongHtml(error,message,data);
          })
        });
      }else{
          _this.getSongData(function(error,message,data){
            _this.showSongHtml(error,message,data);
          })
      }
      $('.onplay-text').css('font-size',multilingual.tranLang("12px"));
    })

    base.scrollPage(function(){
      if(_this.options.isMoreIndex!=1 && _this.options.isMoreIndex!=3){//1为查看更多;3为获取失败，重新获取
        return false;
      }
      _this.getSongData(function(error,message,data){
        _this.showSongHtml(error,message,data);
      })
    });
  },

  //获取歌手头像
  getSingerAvatar:function(callback){
    var _this = this;
    dProtocolOpt.getSingerInfoWithIdByD302(_this.options.id,function(error,message,data){
      // var result = JSON.stringify(data);
      // alert("歌手信息error:"+error+" message:"+message+" data:"+result);
      if(error==0){

        $('.song-content .song-face').css({
          'background-image':'url('+data.picurlhead+data.info.lfid+')',
          'background-repeat':'no-repeat'
        });
      }

      if(typeof callback ==="function"){
        callback();
      }
    });
  },

  getSongData:function(callback){
    var _this = this;
    _this.options.pageNum = $('.song-list').attr('data-page');
    _this.options.pageNum = _this.options.pageNum ? _this.options.pageNum:1;
    if(_this.options.isMoreIndex==4 || _this.options.isMoreIndex==6){
      return false;
    }
    $('.song-content .more-tip').html(base.options.isMore[2]).attr('data-ismore',0);
    multilingual.refreshLang();
    if(_this.options.type==1){
      dProtocolOpt.getSongListWithSingerIdByD544(_this.options.id,_this.options.pageNum,20,function(error,message,data){
        // var result = JSON.stringify(data);
        // alert("歌曲页面的歌曲error:"+error+" message:"+message+" data:"+result);
        callback(error,message,data);
      });
    }else{
      dProtocolOpt.getD332(_this.options.id,_this.options.pageNum,20,function(error,message,data){
        // var result = JSON.stringify(data);
        // alert("新专辑歌曲error:"+error+" message:"+message+" data:"+result);
        if(error==0 && _this.options.pageNum==1){
          $('.song-content .song-face').css({
            'background-image':'url('+data["albumpicurl"]+')',
            'background-repeat':'no-repeat'
          });
        }
        callback(error,message,data);
      });
    }
  },

  //填充歌曲列表
  showSongHtml:function(error,message,data){
    var _this = this;
    if(error==0){
      _this.options.isMoreIndex = data.more;

      if(data.list.length!=0){
        var listData = data.list,
            sequence = 0,
            content = '',
            songNameIcon = "";
        for(i=0;i<listData.length;i++){
          sequence = parseInt(_this.options.pageNum-1)*20+parseInt(i)+1;
          songNameIcon = '<h4><span class="song-name text-ellipsis">'+listData[i]['s']+'</span></h4>';
          if(listData[i]['kp']==13 || listData[i]['kp']==14){//云点歌 listData[i]['kp']==13 || listData[i]['kp']==14
            songNameIcon = '<h4><span class="song-name cloud-song text-ellipsis">'+listData[i]['s']+'</span></h4>';
          }
          console.log('kp值:'+listData[i]['kp']);
          content +='<li>\
                      <div class="show-info" data-songkp="'+listData[i]['kp']+'">\
                        <div class="sequence-box">'+sequence+'</div>\
                          <div class="list-info flex-1">\
                            '+songNameIcon+'\
                            <p>'+listData[i]['g']+'</p>\
                          </div>\
                          <div class="list-btn" data-songid="'+listData[i]['id']+'" data-songname="'+listData[i]['s']+'" data-singername="'+listData[i]['g']+'" data-songkp="'+listData[i]['kp']+'"></div>\
                        </div>';
          if(!(listData[i]['kp']==13|| listData[i]['kp']==14)){
            content +='<div class="top-song" data-songid="'+listData[i]['id']+'" data-songkp="'+listData[i]['kp']+'">\
                        <i langext="more">置顶</i>\
                      </div>';
          }
          content +='</li>';
        }
        $('.song-list').append(content).attr('data-page',parseInt(_this.options.pageNum)+1);
        multilingual.refreshLang();
      }else{
        if(_this.options.pageNum==1){
          _this.options.isMoreIndex = 4;
        }else{
          _this.options.isMoreIndex = 6;//显示有下一页,请求无数据
        } 
      }
    }else{
      _this.options.isMoreIndex = 3;
    }

    if(_this.options.isMoreIndex==0){//加载到底不显示提示语
      _this.options.isMoreIndex = 6;
    }
    $('.song-content .more-tip').html(base.options.isMore[_this.options.isMoreIndex]).attr('data-ismore',_this.options.isMoreIndex).attr('data-method',"getSongData");
    multilingual.refreshLang();
    base.freshScoll();
  }
}
songList.init();